
procedure TMyApp. GetEvent(var Event: TEvent);
var
  W: PWindow;
  HFile: PHelpFile;
  HelpStrm: PDosStream;
  Ch,aux:string;
  ERR:integer;
  N:Longint;
  NN:integer;
  i,ii:byte;
  V1,V2:real;
  B,BB:boolean;
  Math_Pile:GESTMATH.Pointeur_Mathpile;

const MAX_MAC_CHOIX=20;

const
  HelpInUse: Boolean = False;
  Mac_Tab_Choix:array[0..MAX_MAC_CHOIX] of STRING[80] = ('Titre','Choix 1','','','','','','','','','',
                                                         '','','','','','','','','', '');


  function Date:string;

  var A,M,J,JS:word;
      S,X:String;
      i:byte;

  begin
  GetDate(A,M,J,JS);
  str(J:2,S);
  str(M:2,X);
  S:=S+'/'+X;
  str(A:4,X);
  S:=S+'/'+X;
  for i:=1 to length(S) do if S[i]=' ' then S[i]:='0';
  Date:=S;
  end;

  function Time:string;

  var H,M,S,SC:word;
      T,X:String;
      i:byte;

  begin
  gettime(H,M,S,SC);
  str(H:2,T);
  str(M:2,X);
  T:=T+':'+X;
  str(S:2,X);
  T:=T+':'+X;
  for i:=1 to length(T) do if T[i]=' ' then T[i]:='0';
  Time:=T;
  end;

  procedure MacGet(var ch:string);

  begin
  if not eof(MacFic) then
     begin
     readln(MacFic,ch);
     inc(MacLigne);
     end;
  end;


  procedure MacError(Err:string);

  var Num:string[10];

  begin
  MacRead:=false;
  MacPause:=true;
  MacTexte:='';
  {$I-}
  close(MacFic);
  {$I+}
  if ioresult<>0 then Beep;
  str(MacLigne,Num);
  MessageBox(Num+':'+Err, nil, mfError + mfOkButton);
  MAcPause:=false;
  ch:='';
  Redraw;
  end;

  procedure MacSeek(s:string);

  var ch:string;

  begin
  reset(MacFic);
  MacLigne:=1;
  ch:='';
  repeat
    MacGet(ch);
  until eof(MacFic) or (ch='LABEL:'+s);
  if ch<>'LABEL:'+s then
    begin
    MacRead:=false;
    MacTexte:='';
    MacError('Label introuvable: '+s);
    Redraw;
    end;
  end;


  procedure MacConvert;
  var i,ii:byte;
      N:longint;

  begin
  i:=1;
  repeat
    if ch[i]='$'
       then
          if i=length(ch)
               then MacError('N de variable ou $ attendu aprs $')
               else if ch[i+1] in ['$','D','H','L']
                      then begin
                           case Ch[i+1] of
                             '$':aux:='$';
                             'D':aux:=Date;
                             'H':aux:=Time;
                             'L':aux:=MacLire;
                             end;
                           ch:=copy(ch,1,i-1)+aux+copy(ch,i+2,255);
                           i:=i+length(aux);
                           end
                      else begin
                           N:=0;
                           ii:=i;
                           i:=i+1;
                           while (i<=length(ch)) and (CH[i]>='0') and (ch[i]<='9') do
                              begin
                              N:=N*10+ord(ch[i])-ord('0');
                              i:=i+1;
                              end;
                           if N=0 then MacError('N de variable ou $ attendu aprs $');
                           if N>MAX_MAC_VAR then
                              begin
                              str(N,ch);
                              MacError('N de variable hors limite: '+ch);
                              end;
                           if (N>0) and (N<=MAX_MAC_VAR) then
                              begin
                              ch:=copy(ch,1,ii-1)+MacVar[n]+copy(ch,i,255);
                              i:=ii+length(MacVar[n]);
                              end;
                           end
       else i:=i+1;
  until i>length(ch);
  end;


  function MacMenu(nbch:byte):integer;

  var R:TRect;
      C:PRadioButtons;
      Dialog:PDialog;
      Control:Word;
      BData:record
            Form:word;
            end;
      V:PView;
      I:byte;
      Item,NItem:PSItem;

begin
R.Assign(10,5,70,14+nbch);
Dialog:=New(PDialog,Init(R,Mac_Tab_Choix[0]));
with Dialog^ do
  begin
  helpctx:=hcMacMenu0;
  R.Assign(7,5+nbch,17,7+nbch);
  V:=(New (PButton, Init(R,' ~O~k', cmok, bfDefault)));
  V^.helpCtx:=hcMacMenu0;
  insert(V);
  R.Assign(30,5+nbch,43,7+nbch);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.HelpCtx:=hcMacMenu0;
  insert(V);

  R.assign(2,3,58,4+nbch);
  Item:=Nil;
  for i:= 1 to nbch do
     begin
     NItem:=Item;
     Item:=NewSItem(Mac_Tab_Choix[nbch-i+1],NItem);
     end;

  C:=New(PRadioButtons, Init(R, Item));
  C^.helpCtx:=hcMacMenu0;
  insert(C);

  BData.Form:=0;
  SetData(BData);
  Options:=Options or ofCentered;
  end;

MacPause:=true;
Control:=DeskTop^.ExecView(Dialog);
MacPause:=false;

MacMenu:=-1;
if Control=cmcancel then
  begin
    Dispose(Dialog,Done);
    exit;
  end;
Dialog^.GetData(BData);
Dispose(Dialog,Done);
MacMenu:=BData.Form;
end;

begin

  TApplication.GetEvent(Event);

  if (Event.what=evKeyDown) and MacRead and (not eof(MacFic)) and (MacTexte='') and (not MACPause)
   then if Event.CharCode=#27 then MacError('Macro interrompu par ESC');

  if (Event.what=evnothing) and MacRead and (not eof(MacFic)) and (MacTexte='') and (not MACPause)
   then begin
        MacGet(Ch);
        MacConvert;
        if copy(Ch,1,7)='TOUCHE:' then
          begin
          Event.What:=evKeyDown;
          ch:=copy(ch,8,255);
          val(copy(ch,1,pos(':',ch)-1),N,ERR);
          Event.CharCode:=chr(N);
          val(copy(ch,pos(':',ch)+1,255),N,ERR);
          Event.ScanCode:=N;
          end
         else if copy(Ch,1,9)='COMMANDE:' then
               begin
               Event.What:=evCommand;
               ch:=copy(ch,10,255);
               N:=GetCmdNumber(copy(ch,1,255));
               Event.Command:=N;
               {
               N:=GetCmdNumber(copy(ch,1,pos(':',ch)-1));
               Event.Command:=N;
               val(copy(ch,pos(':',ch)+1,255),N,ERR);
               Event.InfoLong:=N;
               }
               end

         else if TOOLCHECK(Event.What,Event.Command,ch,ForceAnnee,ForceMois,ForcePrev,aux)
                then begin ForceOpen:=aux end

         else if copy(ch,1,6)='TEXTE:' then
               begin
               MacTexte:=copy(ch,7,255);
               end

         else if copy(ch,1,5)='EXEC:' then
               begin
               ch:=copy(ch,6,255);
               DosShell(ch);
               end

         else if copy(ch,1,9)='BILANTYP:' then
                if message(Desktop,evbroadcast,cmfindcpt,@self)<>nil
                then begin
                     MacError('Fermer tous les comptes avant de lancer un bilan !');
                     end
                else begin
                     TOOLBILAN(copy(ch,10,255));
                     end

         else if copy(ch,1,6)='SHOW:' then
               begin
               DrawOn:=ch[6]<>'0';
               end

         else if copy(ch,1,6)='NOINS:' then
               begin
               InsertMode:=False;
               Redraw;
               end

         else if copy(ch,1,7)='ALERTE:' then
               begin
               MacPause:=true;
               MessageBox(copy(ch,8,255), nil, mfWarning + mfOkButton);
               MacPause:=false;
               end
         else if (copy(ch,1,6)='SAUVE:') or (copy(ch,1,7)='CHARGE:') then
               begin
               B:=ch[6]=':';
               BB:=true;
               ch:=copy(ch,pos(':',ch)+1,255);
               val(copy(ch,1,pos(':',ch)-1),i,ERR);
               ch:=copy(ch,pos(':',ch)+1,255);
               val(copy(ch,1,pos(':',ch)-1),ii,ERR);
               ch:=copy(ch,pos(':',ch)+1,255);
               if ch[length(ch)]='+' then begin ch:=copy(ch,1,length(ch)-1); BB:=false; end;
               if (i<1) or (i>MAX_MAC_VAR) or (ii<1) or (ii>MAX_MAC_VAR)
                then MacError('Variables hors limite')
                else begin
                     if length(ch)>0 then TOOLOPEN(B,ch);
                     if ii>=i then for N:=i to ii do
                          begin
                          if B then TOOLWRITE(MacVar[N])
                               else MacVar[N]:=TOOLREAD;
                          end;
                     if BB then TOOLCLOSE;
                     end;
               end

         else if (copy(ch,1,5)='MENU:') OR (copy(ch,1,6)='MENUT:')
                                        OR (copy(ch,1,6)='MENUF:') then
               begin
               B:=ch[5]=':';
               BB:=ch[5]='F';
               if B then ch:=copy(ch,6,255) else ch:=copy(ch,7,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N<1) or (N>MAX_MAC_VAR)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else begin
                     if BB then
                       begin
                       ch:=copy(ch,pos(':',ch)+1,255);
                       val(copy(ch,1,pos(':',ch)-1),i,ERR);
                       ch:=copy(ch,pos(':',ch)+1,255);
                       end
                     else
                       begin
                       val(copy(ch,pos(':',ch)+1,255),i,ERR);
                       end;
                     if (i<1) or (i>MAX_MAC_CHOIX)
                          then begin
                               str(i,ch);
                               MacError('Nb de choix incorrect: '+ch);
                               i:=0;
                               end;
                     if BB then TOOLOPEN(false,ch);
                     for ii:=0 to i do
                          begin
                          if BB then begin
                                     ch:=TOOLREAD;
                                     Mac_Tab_Choix[ii]:=ch;
                                     if (copy(ch,1,9)='FINMENUF:') then i:=ii-1;
                                     end
                                else begin
                                     MacGet(ch);
                                     MacConvert;
                                     Mac_Tab_Choix[ii]:=ch;
                                     end;
                          end;
                     if BB then TOOLCLOSE;
                     NN:=MacMenu(i);
                     if B or (NN<0) then str(NN,ch) else ch:=Mac_Tab_Choix[NN+1];
                     MacVar[N]:=ch;
                     end;
               end

         else if copy(ch,1,16)='IMPRIME SECTION:' then
               begin
               aux:=copy(ch,17,255);
               MacGet(ch);
               while (copy(ch,1,length(aux))<>aux) and MacRead do
                  begin
                  if copy(ch,1,1)='~' then
                     begin
                       if not CMDCHECK(ch)
                         then MacError('Mot cls d''impression inconnu:'+ch);
                     end
                   else
                     begin
                     MacConvert;
                     println(ch);
                     end;

                  if MacRead and (eof(MacFic)) then
                     begin
                     ch:=aux;
                     MacError('Fin de fichier avant fin de la section IMPRIME');
                     end
                   else if MacRead then MacGet(ch);
                  end;
               end

         else if copy(ch,1,8)='IMPRIME:' then
               begin
               ch:=copy(ch,9,255);
               println(ch);
               end

         else if copy(ch,1,9)='CONFIRME:' then
               begin
               MacPause:=true;
               ch:=copy(ch,10,255);
               if MessageBox(copy(ch,pos(':',ch)+1,255), nil,mfConfirmation + mfOkCancel)<>cmok
                   then MacSeek(copy(ch,1,pos(':',ch)-1));
               MacPause:=false;
               end

         else if TOOLCHECK2(ch)
                then begin if ch<>'' then MacSeek(ch); end

         else if copy(ch,1,7)='NEXTIN:' then
               begin
               ch:=copy(ch,8,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N<1) or (N>MAX_MAC_VAR) or (ERR<>0)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else begin
                     aux:=MacVar[N];
                     ch:=copy(ch,pos(':',ch)+1,255);
                     TOOLNEXTIT(aux,ch);
                     MacVar[N]:=aux;
                     if ch<>'' then MacSeek(ch);
                     end;
               end

         else if copy(ch,1,2)='+:' then
               begin
               ch:=copy(ch,3,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N<1) or (N>MAX_MAC_VAR) or (ERR<>0)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else begin
                     V1:=0;
                     V2:=0;
                     val(copy(ch,pos(':',ch)+1,255),V1,ERR);
                     val(MacVar[N],V2,ERR);
                     if int(V1+V2)=V1+V2 then str(round(V1+V2),MacVar[N])
                                         else str((V1+V2):8:2,MacVar[N]);
                     end;
               end

         else if copy(ch,1,5)='EVAL:' then
               begin
               ch:=copy(ch,6,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N<1) or (N>MAX_MAC_VAR) or (ERR<>0)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else begin
                     GESTMATH.comp(copy(ch,pos(':',ch)+1,255),Math_Pile);
                     V1:=GESTMATH.evaluer(Math_Pile);
                     if int(V1)=V1 then str(round(V1),MacVar[N])
                                   else str(V1:0:2,MacVar[N]);
                     if GESTMATH.Matherr then MacError('EVAL:'+GESTMATH.Mathmess+':'+ch);
                     GESTMATH.Supp(Math_Pile);
                     end;
               end

         else if copy(ch,1,6)='LABEL:' then
               begin
               end

         else if copy(ch,1,4)='VAR:' then
               begin
               ch:=copy(ch,5,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N<1) or (N>MAX_MAC_VAR)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else MacVar[N]:=copy(ch,pos(':',ch)+1,255);
               end

         else if copy(ch,1,6)='NOSPC:' then
               begin
               ch:=copy(ch,7,255);
               val(ch,N,ERR);
               if (N<1) or (N>MAX_MAC_VAR)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else begin
                     i:=1;
                     while (i<=length(MacVar[n])) and (MacVar[N][i]=' ') do i:=i+1;
                     MacVar[N]:=copy(MacVar[n],i,255);
                     i:=length(MacVar[N]);
                     while (i>=1) and (MacVar[N][i]=' ') do i:=i-1;
                     MacVar[N]:=copy(MacVar[n],1,i);
                     end;
               end

         else if copy(ch,1,6)='COUPE:' then
               begin
               ch:=copy(ch,7,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N<1) or (N>MAX_MAC_VAR)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else begin
                     aux:=copy(ch,pos(':',ch)+1,255);
                     val(copy(aux,pos(':',aux)+1,255),ii,ERR);
                     val(copy(aux,1,pos(':',aux)-1),i,ERR);
                     MacVar[N]:=copy(MacVar[N],i,ii);
                     end;
               end

         else if copy(ch,1,2)='?:' then
               begin
               MacPause:=true;
               ch:=copy(ch,3,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N<1) or (N>MAX_MAC_VAR)
                then begin
                     str(N,ch);
                     MacError('Variable hors limite: '+ch);
                     end
                else begin
                     aux:=MacVar[N];
                     InputBox('Saisie',copy(ch,pos(':',ch)+1,255),aux,LG_MAC_VAR-1);
                     MacVar[N]:=aux;
                     end;
               MacPause:=false;
               end

         else if copy(ch,1,5)='GOTO:' then
               begin
               MacSeek(copy(ch,6,255));
               end

         else if copy(ch,1,7)='SWITCH:' then
               begin
               i:=0;
               ch:=copy(ch,8,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if (N>0) then
                 repeat
                     ch:=copy(ch,pos(':',ch)+1,255);
                     i:=i+1;
                     if i=N then
                         if pos(':',ch)<>0 then MacSeek(copy(ch,1,pos(':',ch)-1))
                                           else MacSeek(ch);
                     if pos(':',ch)=0 then ch:='';
                 until (ch='') or (i=N);
               if N>i then MacError('Valeur dans SWITCH trop grande');
               end

         else if copy(ch,1,6)='GOSUB:' then
               begin
               if MacGosub[0]>=Max_Mac_Gosub then MacError('Trop de GOSUB')
                 else begin
                      inc(MacGosub[0]);
                      MacGosub[MacGosub[0]]:=MacLigne;
                      MacSeek(copy(ch,7,255));
                      end;
               end

         else if copy(ch,1,7)='RETURN:' then
               begin
               if MacGosub[0]=0 then MacError('RETURN sans GOSUB')
                 else begin
                      reset(MacFic);
                      MacLigne:=1;
                      while MacLigne<>MacGosub[MacGosub[0]] do MacGet(ch);
                      dec(MacGosub[0]);
                      end;
               end

         else if copy(ch,1,5)='STOP:' then
               begin
               MacRead:=false;
               close(MacFic);
               Redraw;
               end

         else if copy(ch,1,6)='CHAIN:' then
               begin
               close(MacFic);
               ch:=copy(ch,7,255);
               if pos('.',ch)=0 then ch:=ch+'.MAC';
               MAcName:=ch;
               MacName:=FExpand(MacName);
               assign(MacFic,MacName);
               {$I-}
               reset(MacFic);
               MacLigne:=1;
               {$I+}
               if ioresult<>0 then MacError('Fichier introuvable '+MacName);
               end

         else if (ch<>'') and (copy(ch,1,1)<>'#') then MacError('Erreur de syntaxe: '+ch);

        end;

  
  if (MacTexte<>'') and (not MacPause) then
     begin
     Event.What:=evKeyDown;
     Event.CharCode:=MacTexte[1];
     MacTexte:=copy(MacTexte,2,255);
     Event.ScanCode:=16;

     end;

  if MacRead and eof(MacFic) then
     begin
     MacRead:=false;
     close(MacFic);
     Redraw;
     end;

  if MacOn and (Event.What<>evNothing) and ((Event.What and evmouse)=0) then
     begin
     case Event.What of
       evKeyDown:
          writeln(MacFic,'TOUCHE:',ord(Event.CharCode),':',Event.ScanCode);
       evCommand:
          if (Event.command<>cmcptupdate) and (Event.command<>cmmacendrec)
           then writeln(MacFic,'COMMANDE:',GetCmdName(Event.Command));
      {
       evBroadcast:
          writeln(MacFic,'DIFFUSION:',Event.Command,':',Event.InfoLong);
      }

      else writeln(MacFic,'INCONNU:',Event.What);
      end;
     end;

  if Event.What<>evnothing then LastEventTime:=timer;
  if ((timer-LastEventTime)>(longint(VideoSaveDelay)*3000)) and VideoSave then
     begin
     DoneVideo;
     while Event.What=evnothing do TApplication.GetEvent(Event);
     InitVideo;
     SetVideoMode;
     LastEventTime:=timer;
     Redraw;
     end;
  case Event.What of
    evCommand:
      if (Event.Command = cmHelp) and not HelpInUse then
      begin
        HelpInUse := True;
        HelpStrm := New(PDosStream, Init(CalcHelpName, stOpenRead));
        HFile := New(PHelpFile, Init(HelpStrm));
        if HelpStrm^.Status <> stOk then
        begin
          MessageBox('Ouverture de fichier d''aide impossible.', nil, mfError + mfOkButton);
          Dispose(HFile, Done);
        end
        else
        begin
          W := New(PHelpWindow,Init(HFile, GetHelpCtx));
          if ValidView(W) <> nil then
          begin
            ExecView(W);
            Dispose(W, Done);
          end;
          ClearEvent(Event);
        end;
        HelpInUse := False;
      end;
  end;
end;
