unit OvrDebug;

interface

uses Drivers,Dos,Overlay,Crt;

const NBBLOCK=50;

implementation

var EXEName:string;
    oldval:longint;

begin
  if Lo(DosVersion) >= 3 then EXEName := ParamStr(0)
  else
  begin
    EXEName := FSearch('VBUDGET.EXE', GetEnv('PATH'));
    if EXEName = '' then begin
                         printstr('VBUDGET.EXE introuvable.'#13#10);
                         halt(1);
                         end;
  end;
  EXEName:=copy(EXEName,1,pos('.',EXEName))+'OVR';
  OvrInit(EXEName);
  if OvrResult <> ovrOk then
  begin
    PrintStr('Impossible de trouver les OVERLAYs dans'+EXEName+'.'#13#10);
    Halt(1);
  end;
  OvrInitEMS;
   case OvrResult OF
     ovrIOError:
       WriteLn('Erreur d''E/S sur le fichier de recouvrement.');
     ovrNoEMSDriver:
       WriteLn('Utilisation de l''EMS non trouv.');
     ovrNoEMSMemory:
       WriteLn('Pas assez de mmoire EMS.');
   else
     WriteLn('Utilisation de l''EMS pour une lecture ',
             'plus rapide des partiels.');
   END;
  delay(1000);
  OldVal:=OvrGetBuf;
  OvrSetBuf(OldVal+NBBLOCK * 1024);
end.