{ Tools du programme VBUDGET }

unit vbudtool;

interface

uses Dos,Crt,Memory,Views,Objects,Drivers,App,TextView,Compte,CompteC,XPrint;

function TOOLCHECK(var what:word; var Cmd:word; var ch:string;
  var ForceAnnee:word; var ForceMois:byte; var ForcePrev:boolean; var ForceOpen:string):boolean;

function TOOLCHECK2(var ch:string):boolean;

procedure TOOLNEXTIT(var aux,ch:string);

procedure TOOLOPEN(SAUVE:boolean;ch:string);

procedure TOOLCLOSE;

procedure TOOLWRITE(ch:string);

function TOOLREAD:string;

procedure TOOLBILAN(ch:string);

function CMDCHECK(ch:string):boolean;

implementation

uses cmxxxx;

const MAX_BUF_TERM=30000;

Type PTermWin=^TTermWin;
     TTermWin= object(TWindow)
       Terminal:PTerminal;
       constructor Init(Bounds:TRect; WinTitle:String);
       procedure close; virtual;
       procedure addch(ch:string);

     end;

var ToolFicR:text;
    ToolFicW:text;
    FicOpenR:boolean;
    FicOpenW:boolean;
    OpenTermWin:boolean;
    TermWin:PTermWin;

constructor TTermWin.Init(Bounds:TRect; WinTitle:String);

var VScroll,HScroll:PScrollBar;

begin
TWindow.Init(Bounds, WinTitle, wnNoNumber);
Bounds.Grow(-1,-1);
VScroll:= StandardScrollBar(sbVertical);
HScroll:= StandardScrollBar(sbHorizontal);
GetExtEnt(Bounds);
Bounds.Grow(-1,-1);
HelpCtx := hcNoContext;
{ options:=options+offramed; }
Terminal:=New(PTerminal, Init(Bounds,HScroll,VScroll,MAX_BUF_TERM));
OpenTermWin:=false;
if LowMemory
   then dispose(Terminal, Done)
   else if Application^.ValidView(Terminal)<>nil
           then begin insert(Terminal); OpenTermWin:=true; end;
end;

procedure TTermWin.Close;

begin
OpenTermWin:=false;
TWindow.Close;
end;

procedure TTermWin.addch(ch:string);

var Buf:TextBuf;
    N,D,F:byte;

begin
ch:=ch+Chr(13)+Chr(10);
D:=1;
repeat
  F:=length(ch);
  if F-D>100 then F:=D+100;
  for N:=D to F do Buf[N-D]:=ch[N];
  Terminal^.StrWrite(Buf,F-D+1);
  D:=F+1;
until F=length(ch);
end;

procedure TOOLBILAN(ch:string);

var
  Def:TCptDef;
  fic:text;
  Cat:ECatalog;
  Name:TName;
  MDeb,MFin:word;
  NbTyp:integer;
  FileName: FNameStr;
  Plus:boolean;
  ERR:integer;
  An,X:word;

begin
FileName:=copy(ch,1,pos(':',ch)-1);
Plus:=FileName[1]='+';
if  Plus then FileName:=copy(FileName,2,255);
FileName:=Fexpand(FileName);
assign(Fic,FileName);
{$I-}
if Plus then append(Fic) else rewrite(Fic);
{$I+}
if ioresult<>0 then exit;
Def.Prev:=false;
Def.Mois:=0;
ch:=copy(ch,pos(':',ch)+1,255);
Def.Name:=copy(ch,1,pos(':',ch)-1);
ch:=copy(ch,pos(':',ch)+1,255);
Def.Annee:=0;
val(ch,Def.Annee,ERR);
getdate(An,X,X,X);
if Def.Annee=0 then Def.Annee:=An;
MakeName(Def,Name,Cat);
MDeb:=1;
MFin:=1;
if (Def.Mode and mdmensuel)=mdmensuel then MFin:=12;
writeln(fic,'Bilan du compte: '+Def.Name);
writeln(fic,'');
nbtyp:=0;
for Def.Mois:=MDeb to MFin do
    begin
    if (Def.Mode and mdprev)=mdprev then
       begin
       nbtyp:=0;
       Def.Prev:=false;
       TypBilan(Def,fic,nbtyp,false);
       Def.Prev:=true;
       TypBilan(Def,fic,nbtyp,true);
       end
    else
        begin
        nbtyp:=0;
        Def.Prev:=false;
        TypBilan(Def,fic,nbtyp,true);
        end;
    end;
close(fic);
end;

function TOOLCHECK(var what:word; var Cmd:word; var ch:string;
  var ForceAnnee:word; var ForceMois:byte; var ForcePrev:boolean; var ForceOpen:string):boolean;

var ERR:integer;
    N:byte;

begin
TOOLCHECK:=TRUE;
ForceOpen:='';
         if copy(Ch,1,4)='LIRE' then
               begin
               What:=evCommand;
               Cmd:=cmMacLire;
               end
         else if copy(Ch,1,9)='OUVRECPT:' then
               begin
               ch:=copy(ch,10,255);
               val(copy(ch,1,pos(':',ch)-1),ForceAnnee,ERR);
               ch:=copy(ch,pos(':',ch)+1,255);
               val(copy(ch,1,pos(':',ch)-1),ForceMois,ERR);
               ch:=copy(ch,pos(':',ch)+1,255);
               val(copy(ch,1,pos(':',ch)-1),N,ERR);
               if ForceMois>12 then ForceMois:=12;
               if ForceMois<0 then ForceMois:=0;
               ForcePrev:=(N=1);
               ForceOpen:=copy(ch,pos(':',ch)+1,255);
               What:=evCommand;
               Cmd:=cmopen;
               end
         else TOOLCHECK:=false;
end;

function TOOLCHECK2(var ch:string):boolean;

var ERR:integer;
    N:byte;
    V1,V2:real;
    aux:string;
    R:TRect;
    fic:text;

begin
TOOLCHECK2:=TRUE;
         if copy(ch,1,5)='IDEM:' then
               begin
               ch:=copy(ch,6,255);
               aux:=copy(ch,pos(':',ch)+1,255);
               if copy(aux,pos(':',aux)+1,255)=copy(aux,1,pos(':',aux)-1)
                  then ch:=copy(ch,1,pos(':',ch)-1)
                  else ch:='';
               end
         else if copy(ch,1,2)='=:' then
               begin
               ch:=copy(ch,3,255);
               aux:=copy(ch,pos(':',ch)+1,255);
               val(copy(aux,pos(':',aux)+1,255),V2,ERR);
               val(copy(aux,1,pos(':',aux)-1),V1,ERR);
               if V1=V2
                  then ch:=copy(ch,1,pos(':',ch)-1)
                  else ch:='';
               end

         else if copy(ch,1,2)='>:' then
               begin
               ch:=copy(ch,3,255);
               aux:=copy(ch,pos(':',ch)+1,255);
               val(copy(aux,pos(':',aux)+1,255),V2,ERR);
               val(copy(aux,1,pos(':',aux)-1),V1,ERR);
               if V1>V2
                  then ch:=copy(ch,1,pos(':',ch)-1)
                  else ch:='';
               end

         else if copy(ch,1,2)='<:' then
               begin
               ch:=copy(ch,3,255);
               aux:=copy(ch,pos(':',ch)+1,255);
               val(copy(aux,pos(':',aux)+1,255),V2,ERR);
               val(copy(aux,1,pos(':',aux)-1),V1,ERR);
               if V1<V2
                  then ch:=copy(ch,1,pos(':',ch)-1)
                  else ch:='';
               end

         else if copy(ch,1,3)='<=:' then
               begin
               ch:=copy(ch,4,255);
               aux:=copy(ch,pos(':',ch)+1,255);
               val(copy(aux,pos(':',aux)+1,255),V2,ERR);
               val(copy(aux,1,pos(':',aux)-1),V1,ERR);
               if V1<=V2
                   then ch:=copy(ch,1,pos(':',ch)-1)
                   else ch:='';
               end

         else if copy(ch,1,3)='>=:' then
               begin
               ch:=copy(ch,4,255);
               aux:=copy(ch,pos(':',ch)+1,255);
               val(copy(aux,pos(':',aux)+1,255),V2,ERR);
               val(copy(aux,1,pos(':',aux)-1),V1,ERR);
               if V1>=V2
                   then ch:=copy(ch,1,pos(':',ch)-1)
                   else ch:='';
               end
         else if copy(ch,1,8)='AFFICHE:' then
               begin
               R.Assign(11,2,67,21);
               if not OpenTermWin then
                  begin
                  TermWin:=New(PTermWin, Init(R, 'Rsultat'));
                  if Application^.ValidView(TermWin)=nil
                     then OpenTermWin:=false
                     else Desktop^.insert(TermWin);
                  end;
               if OpenTermWin then TermWin^.addch(copy(ch,9,255));
               ch:=''; { Evite un GOTO en fin de TOOLCHECK2 }
               end
         else if copy(Ch,1,3)='LOG' then
               begin
               ch:=copy(ch,5,255);
               aux:=copy(ch,pos(':',ch)+1,255);
               ch:=copy(ch,1,pos(':',ch)-1);
               Assign(Fic,ch);
               {$I-}
               Append(Fic);
               {$I+}
               if ioresult=0 then
                   begin
                   writeln(Fic,aux);
                   close(Fic);
                   end;
               ch:=''; { Evite un GOTO en fin de TOOLCHECK2 }
               end
         else if copy(ch,1,9)='AFFICHEF:' then
               begin
               R.Assign(11,2,67,21);
               if not OpenTermWin then
                  begin
                  TermWin:=New(PTermWin, Init(R, 'Rsultat'));
                  if Application^.ValidView(TermWin)=nil
                     then OpenTermWin:=false
                     else Desktop^.insert(TermWin);
                  end;
               if OpenTermWin then
                 begin
                 ch:=copy(ch,10,255);
                 Assign(Fic,ch);
                 {$I-}
                 reset(Fic);
                 {$I+}
                 if ioresult=0 then
                   begin
                   while not eof(Fic) do
                     begin
                     readln(Fic,aux);
                     TermWin^.addch(aux);
                     end;
                   close(Fic);
                   end;
                 end;
               ch:=''; { Evite un GOTO en fin de TOOLCHECK2 }
               end
         else if copy(ch,1,11)='FINAFFICHE:' then
               begin
               OpenTermWin:=false;
               ch:=''; { Evite un GOTO en fin de TOOLCHECK2 }
               end
         else TOOLCHECK2:=false;
end;

function CMDCHECK(ch:string):boolean;
begin

   CMDCHECK:=true;
                            if copy(ch,2,4)='INIT'     then printcmd(prinit)
                       else if copy(ch,2,4)='GRAS'     then printcmd(prGras)
                       else if copy(ch,2,5)='NGRAS'    then printcmd(prFinGras)
                       else if copy(ch,2,8)='CONDENSE' then printcmd(prCondense)
                       else if copy(ch,2,9)='NCONDENSE'then printcmd(prFinCondense)
                       else if copy(ch,2,5)='LARGE'    then printcmd(prDoubLarg)
                       else if copy(ch,2,6)='NLARGE'   then printcmd(prFinDoubLarg)
                       else if copy(ch,2,4)='HAUT'     then printcmd(prDoubHaut)
                       else if copy(ch,2,5)='NHAUT'    then printcmd(prFinDoubHaut)
                       else if copy(ch,2,6)='80COLS'   then printcmd(pr10CPI)
                       else if copy(ch,2,6)='96COLS'   then printcmd(pr12CPI)
                       else if copy(ch,2,7)='120COLS'  then printcmd(pr15CPI)
                       else if copy(ch,2,6)='NCOLLE'   then printcmd(prInterLigne8)
                       else if copy(ch,2,5)='COLLE'    then printcmd(prInterLigne6)
                       else if copy(ch,2,9)='BROUILLON'then printcmd(prBrouillon)
                       else if copy(ch,2,8)='COURRIER' then printcmd(prCourrier)
                       else if copy(ch,2,8)='EXPOSANT' then printcmd(prExposant)
                       else if copy(ch,2,9)='NEXPOSANT'then printcmd(prFinExposant)
                       else if copy(ch,2,6)='INDICE'   then printcmd(prIndice)
                       else if copy(ch,2,7)='NINDICE'  then printcmd(prFinIndice)
                       else if copy(ch,2,8)='SOULIGNE' then printcmd(prSouligne)
                       else if copy(ch,2,9)='NSOULIGNE'then printcmd(prFinSouligne)
                       else if copy(ch,2,8)='ITALIQUE' then printcmd(prItalique)
                       else if copy(ch,2,9)='NITALIQUE'then printcmd(prFinItalique)
                       else if copy(ch,2,6)='GAUCHE'   then printcmd(prJustifierG)
                       else if copy(ch,2,6)='CENTRE'   then printcmd(prJustifierC)
                       else if copy(ch,2,5)='DROIT'    then printcmd(prJustifierD)
                       else if copy(ch,2,8)='JUSTIFIE' then printcmd(prJustifierGD)
                       else if copy(ch,2,6)='NORMAL'   then printcmd(prNormal)
                       else if copy(ch,2,4)='SAUT'     then endpage
                       else if copy(ch,2,3)='FIN'      then endprint
   else CMDCHECK:=false;

end;


procedure TOOLNEXTIT(var aux,ch:string);

var ERR:integer;
    NN,N:byte;
    endl,errl:string;
    ok:boolean;

begin
   endl:=copy(ch,1,pos(':',ch)-1);
   ch:=copy(ch,pos(':',ch)+1,255);
   errl:=copy(ch,1,pos(':',ch)-1);
   ch:=copy(ch,pos(':',ch)+1,255);
   NN:=0;
   if (length(ch)>1) and (ch[1]='*') then
     case (upcase(ch[2])) of
       'T': begin
            ch:=copy(ch,5,1); val(ch,NN,ERR);
            if NN=0 then NN:=31 else NN:=30+NN;
            if NN>32 then NN:=30;
            end;
       'M': NN:=22;
       'P': NN:=20;
       'I': NN:=21;
       'U': begin
            ch:=copy(ch,4,2); val(ch,NN,ERR);
            if NN>12 then NN:=0;
            end;
     end;
   N:=0;
   val(aux,N,ERR);
   ok:=false;
   ch:='';
   if not (NN in [1 .. 12, 20 .. 22, 30 .. 32])
     then begin ok:=true; ch:=errl; end
     else
       repeat
         inc(N);
         if NN=N then ok:=true;
         if NN=22 then ok:=true;
         if ((N-2*INT(N/2))+20)=NN then ok:=true;
         if ((N-3*INT(N/3))+30)=NN then ok:=true;
       until (ok or (N>12));
   if ((not ok) or (N>12)) then ch:=endl;
   str(N,aux);
end;

procedure TOOLOPEN(SAUVE:boolean;ch:string);
begin
if SAUVE then
   begin
   if FicOpenW then close(ToolFicW);
   Assign(ToolFicW, ch);
   {$I-}
   rewrite(ToolFicW);
   {$I+}
   FicOpenW:=ioresult=0;
   end
else
   begin
   if FicOpenR then close(ToolFicR);
   Assign(ToolFicR, ch);
   {$I-}
   reset(ToolFicR);
   {$I+}
   FicOpenR:=ioresult=0;
   end;
end;

procedure TOOLCLOSE;
begin
if FicOpenR then close(ToolFicR);
if FicOpenW then close(ToolFicW);
FicOpenR:=false;
FicOpenW:=false;
end;

procedure TOOLWRITE(ch:string);
begin
if FicOpenW then writeln(ToolFicW,ch);
end;


function TOOLREAD:string;
var ch:string;
begin
ch:='';
if FicOpenR then
   if eof(ToolFicR) then ch:='<EOF>' else readln(ToolFicR,ch);
TOOLREAD:=ch;
end;

begin
ficopenR:=false;
ficopenW:=false;
OpenTermWin:=false;
end.