
program vbudget;

{$X+}
{$G+}  { Obligatoire pour viter une erreur code too large }
{$D-}
{$E-}
{$S+}
{$L-}

{$M 49152,65536,655360}

uses {OvrStart, Ovrdebug,}
     Crt,Dos,Drivers,Memory,Views,Menus,Objects,App,Compte,Gadgets,Calendar,
     Calc,Dialogs,MouseDlg,MsgBox,stdDlg,ColorSel,Import,XBeep,Xprint,
     stdbox,HelpFile,vbudhelp,alarm,GestMath,CompteC,vbudtool;

{ Utiliser les DEFINE suivants : MACROON - DEMOVER - PARTICULIER - AXIAL - ROBECOM }

{$define PARTICULIER}

{$define MACROON}

{$F+}

{$ifdef PARTICULIER}
{$endif}

{$ifdef AXIAL}
{$endif}

const VER='6.8';
      REV='c';

      {$ifdef DEMOVER}
      SERIAL_NUMBER=' VERSION DEMO ';
      {$else}
      { SERIAL_NUMBER=' '+#165#188#173#165#176#32#32#32#32#255#254+' '; }
      SERIAL_NUMBER='  FREEWARE ! ';
      {$endif}

      DEFAULT_NAME = 'SANS NOM - ';
      DEFAULT_EDITOR = 'VEDIT';
      MEMORY_MIN = 4096;
      PRG_NAME='VBUDGET.EXE';
      CONFIG_NAME='VBUDGET.CFG';
      HELP_NAME='VBUDHELP.HLP';
      PASS_NAME='VBUDGET.PWD';
      LOCKFILE='VBUDGET.LCK';
      ALARM_FIC='ALARM.CFG';
      DEF_TIMEOUT=500;
      SAVE_DELAY=1;
      LANCE_FIC_NAME='MACROS.LST';

      {Environnement}
      VBUDEXE='VBUDEXE';
      VBUDCONF='VBUDCONF';
      VBUDPASS='VBUDPASS';
      VBUDCPT='VBUDCPT';
      VBUDALARM='VBUDALARM';
      VBUDSPOOLDIR='VBUDSPOOL';
      VBUDEDITOR='VBUDEDITOR';

type PSoftMouse = ^TSoftMouse;
     TSoftMouse = object(TView)
       constructor Init;
       procedure Draw; Virtual;
       end;

type PHintStatusLine = ^THintStatusLine;
     THintStatusLine = object(TStatusLine)
       function Hint(ctx:word):string; virtual;
     end;


type PCptInputLine = ^ TCptInputLine;
     TCptInputLine = object(TInputLine)
       CheckName:byte;          { Niveau de verification : Verif=0,1,2,3 }
       OkName:string[LG_NAME];  { Nom pour vrification avec Verif=3}
       constructor init(var Bounds: TRect; Verif:byte);
       function valid(Cm:word):boolean; virtual;
     end;

type TModifData=record
               Mode:word;
               Prev:word;
               Nom:string[LG_NAME];
               LIB1:string[MAX_LG_LIB];
               LIB2:string[LgCre];
               LIB3:string[LgDeb];
               LCpt:PStringCollection;
               NCpt:Integer;
               end;


type PModifDialog = ^ TModifDialog;
     TModifDialog = object(TDialog)
       ModeBtn:PRadioButtons;
       ModeBox:PCheckBoxes;
       NameLine:PCptInputLine;
       Lib1Line,Lib2Line,Lib3Line:PInputLine;
       procedure HandleEvent(var E:TEvent); virtual;
       function valid(Cm:word):boolean; virtual;

     end;

type

  TMyApp = object(TApplication)
  Clock:PClockView;
  Heap:PHeapView;
  Timeout:Word;
  CPASSWORD:string;
  Alrm:TAlarmColl;
  AlrmStream:PDosStream;
  AllPalette:PPalette;
  VideoMode:Byte;
  VideoSave:Boolean;
  VideoSaveDelay:byte;
  LastEventTime:longint;
  SoftMouse:PSoftMouse;

  constructor Init;
  procedure Idle; virtual;
  procedure InitStatusLine; virtual;
  procedure InitMenuBar; virtual;
  procedure GetEvent(var Event:TEvent); virtual;
  function GetPalette:PPalette; virtual;
  function valid(Cm:word):boolean; virtual;
  function validview(P:PView):PView;
  function PasswordOk:boolean;
  function GetPassword(comment:string):string;
  procedure ChangePassword;
  procedure DosShell(prg:string);
  procedure HandleEvent(var Event:TEvent); virtual;
  procedure SetVideoMode;
  procedure Savepref;
  procedure LoadPref;
  procedure Fenetre;
  procedure FenetreDif;
  procedure ModifCpt;
  procedure EraseCpt;
  procedure OpenCpt;
  procedure OpenPressPap;
  procedure NouvCpt;
  procedure ImporteCpt;
  procedure ShowTotal;
  procedure NewAlarm;
  procedure ChangeAlarm;
  procedure CopyCptTo;
  procedure BilanCpt;
  procedure TypBilanCpt;
  procedure SelPrint;
  procedure MacExec(Auto:byte);
  procedure MacEdit;
  procedure MacRec;
  procedure MacEndRec;
  procedure OutOfMemory; virtual;
  procedure EventError(var Event:TEvent); virtual;
  destructor Done; virtual;
  end;

const cmchanger         = 101;
      cmfenetre         = 102;
      cmprintdef        = 103;

      cmChDir           = 1001;
      cmAbout           = 1002;
      cmCalendar        = 1004;
      cmCalculator      = 1006;
      cmMouse           = 1007;
      cmColors          = 1008;
      cmDosShell        = 1009;
      cmVideoMode       = 1012;
      cmPreferences     = 1013;
      cmimporte         = 1014;
      cmstopprint       = 1015;
      cmshow            = 1016;
      cmfastkey         = 1017;
      cmsavepref        = 1018;
      cmloadpref        = 1019;
      cmmodif           = 1020;
      cmerase           = 1021;
      cmchgpass         = 1022;
      cmmacexec         = 1023;
      cmmacedit         = 1024;
      cmmacrec          = 1025;
      cmmacendrec       = 1026;
      cmfasttyp         = 1027;

      cmshowtotal       = 1200;
      cmnewalarm        = 1201;
      cmchangealarm     = 1202;
      cmcopyCptto       = 1203;
      cmbilancpt        = 1204;
      cmselprint        = 1205;
      cmtypbilancpt     = 1206;
      cmrun             = 10200; { Lance Macro 0  10 = 10100  10110 }

type TCMD=record
           S:string[15];
           N:integer;
          end;
const MAXCMD = 56;
      MAX_MAC_VAR = 20;
      LG_MAC_VAR = 132;
      MAX_MAC_GOSUB = 10;
      MAX_MAC_LANCE = 21;
      MAX_LG_LANCE = 30;

const CMD:array[1..MAXCMD] of TCMD = ( (S:'QUITTE'        ; N:1     ),
                                       (S:'MENU'          ; N:3     ),
                                       (S:'FERME'         ; N:4     ),
                                       (S:'ZOOM'          ; N:5     ),
                                       (S:'RETAILLE'      ; N:6     ),
                                       (S:'FEN_SUIV'      ; N:7     ),
                                       (S:'FEN_PREC'      ; N:8     ),
                                       (S:'HELP'          ; N:9     ),
                                       (S:'OK'            ; N:10    ),
                                       (S:'ANNULER'       ; N:11    ),
                                       (S:'OUI'           ; N:12    ),
                                       (S:'NON'           ; N:13    ),
                                       (S:'BOUTON_DEF'    ; N:14    ),
                                       (S:'COUPER'        ; N:20    ),
                                       (S:'COPIER'        ; N:21    ),
                                       (S:'COLLER'        ; N:22    ),
                                       (S:'VIDE_PRES_PAP' ; N:24    ),
                                       (S:'EMPILE_FEN'    ; N:25    ),
                                       (S:'CASCADE_FEN'   ; N:26    ),
                                       (S:'CHANGER_CPT'   ; N:101   ),
                                       (S:'DUPLIQUE_FEN'  ; N:102   ),
                                       (S:'IMPRESSION'    ; N:103   ),
                                       (S:'SAUVE'         ; N:110   ),
                                       (S:'SAUVE_TOUT'    ; N:111   ),
                                       (S:'AJOUTE_LIGNE'  ; N:112   ),
                                       (S:'IMPRIME'       ; N:113   ),
                                       (S:'IMPRIME_TOUT'  ; N:114   ),
                                       (S:'DEB_ZONE'      ; N:115   ),
                                       (S:'FIN_ZONE'      ; N:116   ),
                                       (S:'DESELECTIONNE' ; N:117   ),
                                       (S:'DEB_ZONE_LIGNE'; N:118   ),
                                       (S:'FIN_ZONE_LIGNE'; N:119   ),
                                       (S:'INV_PRESSE_PAP'; N:120   ),
                                       (S:'DETRUIT_ZONE'  ; N:121   ),
                                       (S:'CLASSE_ZONE'   ; N:122   ),
                                       (S:'CHERCHE_SOLDE' ; N:123   ),
                                       (S:'COP_SOLDE'     ; N:124   ),
                                       (S:'COP_SOLDE_SEL' ; N:125   ),
                                       (S:'MODE_VIDEO'    ; N:1012  ),
                                       (S:'PREFERENCES'   ; N:1013  ),
                                       (S:'IMPORTE'       ; N:1014  ),
                                       (S:'MONT_PRES_PAP' ; N:1016  ),
                                       (S:'TOUCHE_RAPIDE' ; N:1017  ),
                                       (S:'SAUVE_PREF'    ; N:1018  ),
                                       (S:'CHARGE_PREF'   ; N:1019  ),
                                       (S:'MODIFIE_CPT'   ; N:1020  ),
                                       (S:'DETRUIT_CPT'   ; N:1021  ),
                                       (S:'PROTECTION'    ; N:1022  ),
                                       (S:'AFFICHE_TOTAL' ; N:1023  ),
                                       (S:'NOUVELLE_ALRM' ; N:1201  ),
                                       (S:'CHANGE_ALARME' ; N:1202  ),
                                       (S:'COPIER_CPT'    ; N:1203  ),
                                       (S:'BILAN_CPT'     ; N:1204  ),
                                       (S:'CHOISI_IMPRIMT'; N:1205  ),
                                       (S:'OUVRE'         ; N:10001 ),
                                       (S:'NOUVEAU'       ; N:10002 )
                                     );


var NumSansNom:Byte;
    MacName:string;    { Variable pour macros }
    MacFic:Text;
    MacOn:boolean;
    MacTexte:string;
    MacPause:boolean;
    MacVar:array[1..MAX_MAC_VAR] of string[LG_MAC_VAR];
    MacGosub:array[0..MAX_MAC_GOSUB] of word;
    MacLigne:word;
    MacLance:array[1..MAX_MAC_LANCE] of string [MAX_LG_LANCE];
    MacNbLance:word;
    ForceAnnee:word;
    ForceMois:byte;
    ForcePrev:boolean;
    ForceOpen:string[LG_NAME];

{$I vbudget1.pas}

constructor TMyApp.Init;

var R:TRect;
    OldDir:String;
    Ev:Tevent;

begin
TApplication.Init;
RegisterObjects;
RegisterViews;
RegisterMenus;
RegisterDialogs;
RegisterApp;
RegisterHelpFile;
RegisterCalendar;
RegisterCalc;
RegisterAlarmColl;

{$I-}
getdir(0,OldDir);
if GetEnv(VBUDSPOOLDIR)<>'' then chdir(getenv(VBUDSPOOLDIR));
if ioresult<>0 then
    begin
    writeln(' Rpertoire "',GetEnv(VBUDSPOOLDIR),'" incorrect dans ',VBUDSPOOLDIR,'.');
    halt(1);
    end
   else if getenv(VBUDSPOOLDIR)<>'' then
    begin
    xprint.BaseDir:=getenv(VBUDSPOOLDIR);
    end;
{$I+}
chdir(OldDir);
xprint.init;

BeepTyp:=1;
Timeout:=DEF_TIMEOUT;
NumSansNom:=0;
LowMemSize:=MEMORY_MIN;

GetExtent(R);
R.A.X:=R.B.X-9;
R.B.Y:=R.A.Y+1;
Clock:=new(PClockView, Init(R));
Clock^.GrowMode:=GfGrowHix+GfGrowLox;
Insert(Clock);

GetExtent(R);
Dec(R.B.X);
R.A.X:=R.B.X-9;
R.A.Y:=R.B.Y-1;
Heap:=new(PHeapView, Init(R));
Heap^.GrowMode:=GfGrowAll;
Insert(Heap);

SoftMouse:=new(PSoftMouse, Init);
Insert(SoftMouse);
SoftMouse^.Hide;
VideoMode:=0;
VideoSave:=false;
VideoSaveDelay:=SAVE_DELAY;
LastEventTime:=Timer;
loadpref;
setprintmode(timeout<>0,timeout);
CPASSWORD:=GetEnv(VBUDPASS);
if paramcount>=2 then CPASSWORD:=paramstr(2);
StrUpCase(CPASSWORD);
{$I-}
getdir(0,OldDir);
if GetEnv(VBUDALARM)<>'' then chdir(getenv(VBUDALARM));
if ioresult<>0 then
    begin
    writeln(' Rpertoire "',GetEnv(VBUDALARM),'" incorrect dans ',VBUDALARM,'.');
    halt(1);
    end;
{$I+}

AlrmStream:=new(PDosStream,Init(ALARM_FIC,stopen));
if AlrmStream^.Status<>stok then begin
                                 AlrmStream:=new(PDosStream,Init(ALARM_FIC,stcreate));
                                 Alrm.Init(0,1);
                                 RepeatColl.Init(0,1);
                                 end
                            else begin
                                 Alrm.Load(AlrmStream^);
                                 RepeatColl.Load(AlrmStream^);
                                 end;
chdir(OldDir);
{$ifdef DEMOVER}
Beep;
MessageBox(^C+'Version demonstration - limite  15 jours !',nil,mfInformation+mfOkButton);
{$endif}
{$ifdef ROBECOM}
Beep;
Ev.what:=evcommand;
Ev.command:=cmabout;
PutEvent(Ev);
{$endif}
end;

function TMyApp.validview(P:PView):PView;

begin
if LowMemory then VidePressPap;
ValidView:=TProgram.ValidView(P);
end;

procedure TMyApp.SetVideoMode;

var NewMode,LigneS:word;
    R:Trect;

begin
if (VideoMode and 1)=1 then begin
                            ShadowSize.X := 1;
                            NewMode := ScreenMode or smFont8x8;
                            end
                       else begin
                            ShadowSize.X := 2;
                            NewMode := ScreenMode and (not smFont8x8);
                            end;
NewMode:=ScreenMode or smFont8x8;
if (videoMode and 1)<>1 then NewMode:=NewMode xor smFont8x8;
if (VideoMode and 2)<>2
  then begin
       SetScreenMode(NewMode);
       SoftMouse^.hide;
       end
  else begin
       HideMouse;
       LigneS:=0;
       if (VideoMode and 1)=1
          then begin
               R.Assign(0,0,132,50);
               asm
                push bp;
                push sp;
                push ss;
                push ds;

                mov ax,$0055; {0054 pour 43 lignes }
                int $10;

                mov ax,$1112  { Mode 50 lignes }
                mov bx,$0000;
                int $10;

                pop ds;
                pop ss;
                pop sp;
                pop bp;
                end;
               ScreenHeight:=50;
               ScreenWidth:=132;
               LigneS:=392;
               end
          else begin
               R.ASSign(0,0,132,25);
               asm
                push bp;
                push sp;
                push ss;
                push ds;

                mov ax,$0055;  { 132 Colonnes en 25 lignes }
                int $10;

                pop ds;
                pop ss;
                pop sp;
                pop bp;
                end;
               LigneS:=192;
               ScreenHeight:=25;
               ScreenWidth:=132;
               end;
       if MouseEvents then
           asm
           push bp;
           push sp;
           push ss;
           push ds;

           mov ax,$0008;
           mov cx,$0;
           mov dx,LigneS;
           int $33;

           pop ds;
           pop ss;
           pop sp;
           pop bp;
           end;
       InitScreen;
       ChangeBounds(R);
       if MouseEvents then SoftMouse^.Show;
       ShowCursor;
       HideCursor;
       end;
end;


procedure TMyApp.ChangePassword;

var OLDC,Pass:string;
    R:TRect;
    f:text;

begin
OLDC:=CPASSWORD;
assign(f,PASS_NAME);
{$I-}
reset(f);
{$I+}
if ioresult<>0 then Pass:=''
               else begin
                    readln(f,pass);
                    close(f);
                    end;
StrUpCase(Pass);
if Pass<>'' then
   begin
   CPASSWORD:='';
   GetPassword('Entrez l''ancien mot de passe');
   if Pass<>CPASSWORD then
      begin
      Beep;
      R.assign(20,7,60,14);
      MessageBoxRect(R,^C+'Mot de Passe incorrect',
        nil, mfError + mfOkButton);
      CPASSWORD:=OLDC;
      exit;
      end;
   end;
CPASSWORD:='';
Pass:=GetPassword('Entrez le nouveau mot de passe');
CPASSWORD:='';
if GetPassword('Confirmez le nouveau mot de passe')<>Pass then
   begin
   Beep;
   R.assign(20,7,60,14);
   MessageBoxRect(R,^C+'Mot de Passe mal confirm',
        nil, mfError + mfOkButton);
   CPASSWORD:=OLDC;
   exit;
   end;
rewrite(f);
writeln(f,Pass);
close(f);
CPASSWORD:=OLDC;
end;

function TMyApp.Getpassword(comment:string):string;

var R:TRect;
    SS:PInputLine;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    PassData:record
             Pass:string[255];
             end;
    V:PView;

begin
MacPause:=true;
GetPassword:='';
stop:=false;
R.Assign(10,5,61,10);
Dialog:=New(PDialog,Init(R, ''));
with Dialog^ do
  begin
  helpctx:=hcCNouvBox;

  R.Assign(1,1,50,2);
  insert(New(PStaticText,Init(R,^C+Comment)));

  R.Assign(16,3,32,4);
  SS:=New(PSecretInput, Init(R,255,'*'));
  SS^.helpCtx:=hcCPassEntry;
  insert(SS);
  {
  R.Assign(2,3,16,4);
  Insert(New(PLabel, Init(R, 'Mot de Passe: ' , SS)));
  }

  PassData.Pass:=CPASSWORD;
  SetData(PassData);
  Options:=Options or ofCentered;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then begin
                         GetPassword:=CPASSWORD;
                         stop:=true;
                         end;
Dialog^.GetData(PassData);
Dispose(Dialog,Done);
MacPause:=false;
if stop then exit;
CPASSWORD:=PassData.Pass;
StrUpCase(CPASSWORD);
GetPassword:=CPASSWORD;
end;


function TMyApp.PasswordOk:boolean;

var f:text;
    pass:string;
    OK:boolean;
    R:TRect;

begin
PasswordOk:=true;
assign(f,PASS_NAME);
{$I-}
reset(f);
{$I+}
if ioresult<>0 then exit;
readln(f,pass);
close(f);
StrUpCase(pass);
if Pass<>CPASSWORD then
   begin
   Ok:=getpassword('Entrez le mot de passe')=pass;
   if not OK then begin
                  MacPause:=true;
                  Beep;
                  R.assign(20,7,60,14);
                  MessageBoxRect(R,^C+'Mot de Passe incorrect',
                     nil, mfError + mfOkButton);
                  MacPause:=false;
                  end;
   PasswordOK:=OK;
   end;

end;

function TMyApp. valid(Cm:word):boolean;

var ok:boolean;
    R:TRect;

begin
ok:=TApplication.Valid(cm);
if (cm=cmquit) then
  begin
  if not Empty then
    begin
    R.Assign(5,7,75,14);
    Beep;
    case MessageBoxRect(R,^C+' Quitter maintenant stoppera l''impression',nil, mfWarning + mfOkCancel) of
      cmok: Stopall(True);
      cmcancel:ok:=false;
      end;
    end else Destroy;

  end;
Valid:=ok;
end;

{$I VBUDGET2}  {procedure TMyApp. GetEvent(var Event: TEvent) }

procedure TMyApp.ShowTotal;

var R:TRect;

begin
if TotalFen<>nil then TotalFen^.MakeFirst
                 else begin
                      R.Assign(0,1,50,4);
                      TotalFen:=new(PTotalFen, Init(R,'',wnnonumber));
                      TotalFen^.options:=TotalFen^. options+ofCenterX;
                      Desktop^.Insert(TotalFen);
                      end;
end;

function TMyApp.GetPalette: PPalette;
const
  CNewColor = CColor + CHelpColor;
  CNewBlackWhite = CBlackWhite + CHelpBlackWhite;
  CNewMonochrome = CMonochrome + CHelpMonochrome;
  P: array[apColor..apMonochrome] of TPalette =
    (CNewColor, CNewBlackWhite, CNewMonochrome);
begin
  GetPalette := @P[AppPalette];
  AllPalette := @P[ApColor];
end;

procedure TMyApp.savepref;

 var fic:FILE;
     version:real;
     ERR:integer;

begin
assign(fic,CalcPrefName);
{$I-}
rewrite(fic,1);
{$I+}
if ioresult<>0 then exit;
val(VER,version,ERR);
blockwrite(fic,version,sizeof(version));
blockwrite(fic,Fastkey,sizeof(FastKey));
blockwrite(fic,InsType,sizeof(InsType));
blockwrite(fic,BeepTyp,sizeof(BeepTyp));
GetPalette;
blockwrite(fic,AllPalette^,sizeof(TPalette)*3);
blockwrite(fic,AutoInsert,sizeof(AutoInsert));
blockwrite(fic,AutoSaveMode,sizeof(AutoSaveMode));
blockwrite(fic,InsertMode,sizeof(InsertMode));
blockwrite(fic,VideoMode,sizeof(VideoMode));
blockwrite(fic,DoubleDelay,sizeof(DoubleDelay));
blockwrite(fic,Timeout,sizeof(Timeout));
blockwrite(fic,PrintDriver,sizeof(PrintDriver));
blockwrite(fic,CheckDate,sizeof(CheckDate));
blockwrite(fic,VideoSave,sizeof(VideoSave));
blockwrite(fic,VideoSaveDelay,sizeof(VideoSaveDelay));
blockwrite(fic,FastTyp,sizeof(FastTyp));
close(fic);
end;

procedure TMyApp.loadpref;

 var fic:FILE;
     NewMode:Word;
     version:real;

begin
assign(fic,CalcPrefName);
{$I-}
reset(fic,1);
{$I+}
if ioresult<>0 then exit;
blockread(fic,version,sizeof(version));
blockread(fic,FastKey,sizeof(FastKey));
blockread(fic,InsType,sizeof(InsType));
blockread(fic,BeepTyp,sizeof(BeepTyp));
GetPalette;
blockread(fic,AllPalette^,sizeof(TPalette)*3);
blockread(fic,AutoInsert,sizeof(AutoInsert));
blockread(fic,AutoSaveMode,sizeof(AutoSaveMode));
blockread(fic,InsertMode,sizeof(InsertMode));
blockread(fic,VideoMode,sizeof(VideoMode));
SetVideoMode;
blockread(fic,DoubleDelay,sizeof(DoubleDelay));
blockread(fic,Timeout,sizeof(Timeout));
blockread(fic,printDriver,sizeof(PrintDriver));
blockread(fic,CheckDate,sizeof(CheckDate));
blockread(fic,VideoSave,sizeof(VideoSave));
blockread(fic,VideoSaveDelay,sizeof(VideoSaveDelay));
setprintmode(Timeout<>0,Timeout);
if version=6.4 then blockread(fic,FastTyp,sizeof(FastTyp[1])*10);
if version>6.4 then blockread(fic,FastTyp,sizeof(FastTyp));
close(fic);
DoneMemory;
Redraw;
end;

procedure TMyApp.OutOfMemory;
begin
  Beep;
  MessageBox('Mmoire insuffisante pour achever l''opration.',
    nil, mfError + mfOkButton);
end;


procedure TMyApp.Idle;

   function IsTileable(P:PView):Boolean; far;
   begin
   IsTileable:=P^.Options and oftileable<>0;
   end;

   var hh,mm,ss,s1:word;

begin
TApplication.Idle;
SoftMouse^.MoveTo(MouseWhere.X,MouseWhere.Y+1);
SoftMouse^.MakeFirst;
if not MacPause then
   begin
   MacPause:=true;
   Alrm.Check;
   RepeatColl.Check;
   MacPause:=false;
   end
else
   begin
   Alrm.Check;
   RepeatColl.Check;
   end;
Clock^.Update;
Heap^.Update;
if Desktop^.Firstthat(@IsTileable)<>nil
 then EnableCommands([cmtile,cmCascade])
 else DisableCommands([cmtile,cmCascade]);
if message(Desktop,evbroadcast,cmfindcpt,@self)<>nil
 then begin
      EnableCommands([cmchanger,cmCsave,cmCsaveall,cmCnewline,cmprintdef,cmprintall,cmfenetre]);
      EnableCommands([cmSoldeCopy,cmSoldeSCopy,cmDebZone,cmEndZone,cmDebLZone,cmEndLZone,cmClearZone,cmsearch]);
      if OkCutCopy then EnableCommands([cmcut,cmcopy,cmdestroy,cmclass])
                   else DisableCommands([cmcut,cmcopy,cmdestroy,cmclass]);
      end
 else begin
      DisableCommands([cmchanger,cmCsave,cmCsaveall,cmCnewline,cmprintdef,cmprintall,cmfenetre,cmsearch,cmSoldeCopy]);
      DisableCommands([cmSoldeSCopy,cmDebZone,cmEndZone,cmDebLZone,cmEndLZone,cmClearZone,cmcut,cmcopy,cmdestroy,cmclass]);
      end;

if CptPressPap^.VCompte^.SelecZone.empty
 then DisableCommands([cmpaste,cminvpresspap])
 else EnableCommands([cmpaste,cminvpresspap]);

if CptPressPap^.VCompte^.NbLignes=0
 then DisableCommands([cmclear])
 else EnableCommands([cmclear]);

ItPrint; { Retourne vrai si on a imprim }
end;



procedure TMyApp.Fenetre;

var VFenetre:PFenCpt;
    R:TRect;
    OldRep:string;

begin

if message(Desktop,evbroadcast,cmfindcpt,@self)<>nil then
  begin
  R.Assign(11,2,67,21);
  getdir(0,OldRep);
  if LastCptDef.Repert<>'' then chdir(LastCptDef.Repert);
  VFenetre:=New(PFenCpt, Init(R,LastCptDef));
  VFenetre^.palette:=wpBluewindow;
  VFenetre^.DragMode:=dmlimitLoy;
  VFenetre^.HelpCtx := hcCptFen;
  Desktop^.insert(ValidView(VFenetre));
  chdir(OldRep);
  end;

end;


procedure TMyApp.FenetreDif;

var VFenetre:PFenCpt;
    R:TRect;
    Def:TCptDef;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    OuvData:record
            Prev:word;
            Annee:string[4];
            Mois:string[2];
            end;
    C:PRadioButtons;
    S:PNumInputLine;
    V:PView;
    An,Mo,Jo,Js:word;
    E:Integer;
    OldRep:string;
    Po:Pointer;

begin
if message(Desktop,evbroadcast,cmfindcpt,@self)<>nil then
  begin
  stop:=false;
  Def:=LastCptDef;
  getdir(0,OldRep);
  if LastCptDef.Repert<>'' then chdir(LastCptDef.Repert);
  R.Assign(20,5,59,15);
  Dialog:=New(PDialog,Init(R, 'Changer'));
  with Dialog^ do
    begin
    R.Assign(3,2,36,3);
    V:=(New (PStaticText, Init(R,'Compte : '+Def.Name)));
    V^.helpctx:=hcCCptName;
    Insert(V);

    R.Assign(2,7,14,9);
    V:=(New (PButton, Init(R,'~C~hanger', cmok, bfDefault)));
    V^.helpctx:=hcCChangerBtn;
    Insert(V);
    R.Assign(22,7,34,9);
    V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
    V^.helpctx:=hcCancelBtn;
    Insert(V);

    R.assign(2,4,20,6);
    C:=New(PRadioButtons, Init(R, NewSItem('~N~ormal',
                                NewSItem('~P~rvision',
                                nil))));
    C^.helpctx:=hcCRadioN;
    insert(C);

    R.Assign(31,4,37,5);
    S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
    S^.helpctx:=hcCAnneeOpen;
    insert(S);
    R.Assign(22,4,31,5);
    Insert(New(PLabel, Init(R, '~A~nne : ' , S)));
    helpctx:=hcCmoisOpen;
    R.Assign(31,5,37,6);
    S:=New(PNumInputLine, Init(R, 2,1,12,^C+'Mois incorrect'));
    S^.helpctx:=hcCmoisOpen;
    insert(S);
    R.Assign(22,5,31,6);
    Insert(New(PLabel, Init(R, '~M~ois  : ' , S)));

    getdate(An,Mo,Jo,Js);
    Str(An:4,OuvData.Annee);
    Str(Mo:2,OuvData.Mois);
    if Def.Annee<>0 then Str(Def.Annee:4,OuvData.Annee);
    if Def.Mois <>0 then Str(Def.Mois:2,OuvData.Mois);
    OuvData.Prev:=0;
    if Def.prev then OuvData.prev:=1;
    SetData(OuvData);
    Options:=Options or ofCentered;
    helpctx:=hcCChangeBox;
    end;

  Control:=DeskTop^.ExecView(Dialog);

  if Control=cmcancel then Stop:=True;
  Dialog^.GetData(OuvData);

  R.assign(20,5,60,12);

  val(OuvData.Annee,An,E);
  val(OuvData.Mois,Mo,E);

  Dispose(Dialog,Done);

  if stop then begin
               chdir(OldRep);
               exit;
               end;

  Def.Prev:=OuvData.Prev=1;
  Def.Mois:=Mo;
  Def.Annee:=An;

  R.Assign(11,2,71,21);
  VFenetre:=New(PFenCpt, Init(R,Def));
  VFenetre^.palette:=wpBluewindow;
  VFenetre^.DragMode:=dmlimitLoy;
  VFenetre^.HelpCtx := hcCptFen;
  Desktop^.insert(ValidView(VFenetre));

  chdir(OldRep);
  end;

end;


procedure TMyApp.OpenCpt;

var VFenetre:PFenCpt;
    R:TRect;
    Def:TCptDef;
    An,Mo,Jo,Js:word;
    NUM:string[3];
    C:PRadioButtons;
    S:PNumInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    OuvData:record
            Prev:word;
            Annee:string[4];
            Mois:string[2];
            LCpt:PStringCollection;
            NCpt:Integer;
            end;
    LCpt:PStringCollection;
    Ch:PString;
    L:PListBox;
    V:PView;
    ScBar:PScrollBar;

begin
if not PasswordOk then exit;
LCpt:=new(PStringCollection,Init(10,1) );
Stop:=not MakeList(LCpt);

if ForceOpen='' then
begin
R.Assign(10,3,70,19);
Dialog:=New(PDialog,Init(R, 'Ouvrir'));
with Dialog^ do
  begin
  R.Assign(42,2,53,4);
  V:=(New (PButton, Init(R,'~O~uvrir', cmok, bfDefault)));
  V^.HelpCtx:=hcCOpenBtn;
  insert(V);
  R.Assign(42,4,53,6);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);

  R.assign(40,6,55,8);
  C:=New(PRadioButtons, Init(R, NewSItem('~N~ormal',
                                NewSItem('~P~rvision',
                                nil))));
  C^.HelpCtx:=hcCRadioN;
  insert(C);

  R.Assign(49,9,55,10);
  S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
  S^.HelpCtx:=hcCAnneeOpen;
  insert(S);
  R.Assign(40,9,49,10);
  Insert(New(PLabel, Init(R, '~A~nne : ' , S)));
  R.Assign(49,10,53,11);
  S:=New(PNumInputLine, Init(R, 2,1,12,^C+'Mois incorrect'));
  S^.HelpCtx:=hcCMoisOpen;
  insert(S);
  R.Assign(40,10,49,11);
  Insert(New(PLabel, Init(R, '~M~ois  : ' , S)));

  R.Assign(35,3,36,14);
  ScBar:=New(PScrollBar, Init(R));
  ScBar^.options:=ScBar^.options or ofpostprocess;
  insert(ScBar);
  R.Assign(2,3,35,14);
  L:=New(PListBox, Init(R,1,ScBar));
  L^.options:=L^.options or offramed;
  L^.HelpCtx:=hcCList;
  insert(L);
  R.Assign(2,1,36,2);
  Insert(New(PLabel, Init(R, '~C~ompte : ' , L)));

  getdate(An,Mo,Jo,Js);
  Str(An:4,OuvData.Annee);
  Str(Mo:2,OuvData.Mois);
  OuvData.Prev:=0;
  OuvData.LCpt:=LCpt;
  OuvData.NCpt:=0;
  SetData(OuvData);
  Options:=Options or ofCentered;
  helpctx:=hcCOpenBox;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(OuvData);

R.assign(20,5,60,12);

val(OuvData.Annee,An,E);
val(OuvData.Mois,Mo,E);

Dispose(Dialog,Done);
if not stop then
  begin
  Def.Name:=STRING(LCpt^.At(OuvData.NCpt)^);
  Def.Prev:=OuvData.Prev=1;
  end;
end
else
begin  { mode forceopen }
getdate(An,Mo,Jo,Js);
Def.Name:=ForceOpen;
Def.Prev:=ForcePrev;
if ForceAnnee<>0 then An:=ForceAnnee;
if ForceMois<>0 then Mo:=ForceMois;
ForceOpen:='';
end;

if stop then begin
             dispose(LCpt,Done);
             exit;
             end;

Def.Mois:=Mo;
Def.Annee:=An;
Def.Mode:=mdnorm+mdseul;
R.Assign(11,2,71,21);
VFenetre:=New(PFenCpt, Init(R, Def));

VFenetre^.palette:=wpBluewindow;
VFenetre^.DragMode:=dmlimitLoy;
VFEnetre^.HelpCtx:= hcCptFen;

Desktop^.insert(ValidView(VFenetre));
Dispose(LCpt,Done);
end;

procedure TMyApp.EraseCpt;

var R:TRect;
    Def:TCptDef;
    C:PRadioButtons;
    S:PNumInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    OuvData:record
            LCpt:PStringCollection;
            NCpt:Integer;
            end;
    LCpt:PStringCollection;
    Ch:PString;
    L:PListBox;
    V:PView;
    ScBar:PScrollBar;

begin
if not PasswordOk then exit;

LCpt:=new(PStringCollection,Init(10,1) );
Stop:=not MakeList(LCpt);

R.Assign(10,3,70,19);
Dialog:=New(PDialog,Init(R, 'Ouvrir'));

with Dialog^ do
  begin
  R.Assign(42,6,53,8);
  V:=(New (PButton, Init(R,'~E~ffacer', cmok, bfDefault)));
  V^.HelpCtx:=hcCEraseBtn;
  insert(V);
  R.Assign(42,10,53,12);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);

  R.Assign(35,3,36,14);
  ScBar:=New(PScrollBar, Init(R));
  ScBar^.options:=ScBar^.options or ofpostprocess;
  insert(ScBar);
  R.Assign(2,3,35,14);
  L:=New(PListBox, Init(R,1,ScBar));
  L^.options:=L^.options or offramed;
  L^.HelpCtx:=hcCList;
  insert(L);
  R.Assign(2,1,36,2);
  Insert(New(PLabel, Init(R, '~C~ompte : ' , L)));

  OuvData.LCpt:=LCpt;
  OuvData.NCpt:=0;
  SetData(OuvData);
  Options:=Options or ofCentered;
  helpctx:=hcCEraseBox;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(OuvData);

R.assign(20,5,60,12);

Dispose(Dialog,Done);
if stop then begin
             dispose(LCpt,Done);
             exit;
             end;

Def.Name:=STRING(LCpt^.At(OuvData.NCpt)^);

R.assign(5,6,75,15);
if MessageBoxRect(R,^C+'Attention cette opration est destructive !!'+#13+#13
                   +^C+' Destruction DEFINITVE du compte '+Def.Name,
       nil, mfConfirmation + mfOkCancel)=cmok then
    begin
    DelName(Def);
    R.assign(20,7,60,15);
    MessageBoxRect(R,^C+'Compte '+Def.Name+' detruit.',
       nil, mfInformation + mfOkButton);
    end;

Dispose(LCpt,Done);
end;



procedure TMyApp.ModifCpt;

var R:TRect;
    OldDef,Def:TCptDef;
    NUM:string[3];
    B:PCheckBoxes;
    C:PRadioButtons;
    S:PNumInputLine;
    SS:PInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PModifDialog;
    Control:Word;
    ModifData:TModifData;
    LCpt:PStringCollection;
    Ch:PString;
    L:PListBox;
    V:PView;
    ScBar:PScrollBar;
    X:ECatalog;
    NFIC:TName;

begin
if not passwordOk then exit;

LCpt:=new(PStringCollection,Init(10,1) );
Stop:=not MakeList(LCpt);

if stop then begin
             dispose(LCpt,Done);
             beep;
             exit;
             end;

R.Assign(10,2,70,21);
Dialog:=New(PModifDialog,Init(R, 'Modifier'));
with Dialog^ do
  begin
  R.Assign(42,2,54,4);
  V:=(New (PButton, Init(R,'~M~odifier', cmok, bfDefault)));
  V^.HelpCtx:=hcCModifBtn;
  insert(V);
  R.Assign(42,4,54,6);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);

  R.assign(40,6,55,9);
  C:=New(PRadioButtons, Init(R, NewSItem('~U~nique',
                                NewSItem('~M~ensuel',
                                NewSItem('~A~nnuel',
                                nil)))));
  C^.helpCtx:=hcCTypeU;
  insert(C);
  ModeBtn:=C;

  R.assign(40,10,55,11);
  B:=New(PCheckBoxes, Init(R, NewSItem('~P~rvision',
                              nil)));
  B^.HelpCtx:=hcCCasePrev;
  insert(B);

  ModeBox:=B;

  R.Assign(40,13,55,14);
  SS:=New(PCptInputLine, Init(R,3));
  SS^.helpCtx:=hcCCptName;
  insert(SS);
  NameLine:=PCptInputLine(SS);
  R.Assign(40,12,55,13);
  insert(New(PLabel, Init(R, '~N~ouveau nom : ' , SS)));

  R.Assign(2,16,28,17);
  SS:=New(PInputLine, Init(R,MAX_LG_LIB));
  SS^.helpCtx:=hcCLib;
  insert(SS);
  Lib1Line:=SS;
  R.Assign(2,15,28,16);
  Insert(New(PLabel, Init(R, 'Libell ~1~ : ' , SS)));

  R.Assign(29,16,41,17);
  SS:=New(PInputLine, Init(R,LgCre));
  SS^.helpCtx:=hcCLib;
  insert(SS);
  Lib2Line:=SS;
  R.Assign(29,15,41,16);
  Insert(New(PLabel, Init(R, 'Libell ~2~ : ' , SS)));

  R.Assign(44,16,56,17);
  SS:=New(PInputLine, Init(R,LgDeb));
  SS^.helpCtx:=hcCLib;
  insert(SS);
  Lib3Line:=SS;
  R.Assign(44,15,56,16);
  Insert(New(PLabel, Init(R, 'Libell ~3~ : ' , SS)));

  R.Assign(35,3,36,14);
  ScBar:=New(PScrollBar, Init(R));
  ScBar^.options:=ScBar^.options or ofpostprocess;
  insert(ScBar);
  R.Assign(2,3,35,14);
  L:=New(PFocusListBox, Init(R,1,ScBar));
  L^.options:=L^.options or offramed;
  L^.HelpCtx:=hcCList;
  insert(L);
  R.Assign(2,1,36,2);
  Insert(New(PLabel, Init(R, '~C~ompte : ' , L)));


  ModifData.Mode:=0;
  ModifData.Prev:=0;
  ModifData.LIB1:=' LIBELLE ';
  ModifData.LIB2:=' CREDIT ';
  ModifData.LIB3:=' DEBIT  ';
  ModifData.Nom:='';
  ModifData.LCpt:=LCpt;
  ModifData.NCpt:=0;
  SetData(ModifData);
  Options:=Options or ofCentered;
  helpctx:=hcCOpenBox;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(ModifData);

R.assign(20,5,60,12);

Dispose(Dialog,Done);

if stop then begin
             dispose(LCpt,Done);
             exit;
             end;

OldDef.Name:=STRING(LCpt^.At(ModifData.NCpt)^);
Def.Name:=ModifData.nom;
Def.Prev:=false;
Def.Mois:=1;
Def.Annee:=1991;
if ModifData.Prev=0 then Def.Mode:=mdnorm else Def.Mode:=mdprev;
case ModifData.Mode of
  0:Def.Mode:=Def.Mode or mdseul;
  1:Def.Mode:=Def.Mode or mdmensuel;
  2:Def.Mode:=Def.Mode or mdannuel;
 end;

X.LIB1:=ModifData.LIB1;
X.LIB2:=ModifData.LIB2;
X.LIB3:=ModifData.LIB3;

ModifName(OldDef,Def,NFIC,X);

Dispose(LCpt,Done);
end;


procedure TMyApp.OpenPressPap;

var VFenetre:PFenCpt;
    R:TRect;
    Def:TCptDef;

begin
Def.Name:=PP_FEN_NAME;
Def.Prev:=false;
Def.Mois:=0;
Def.Annee:=0;
Def.Mode:=mdnorm+mdseul+mdPressPap;
R.Assign(11,2,71,21);
VFenetre:=New(PFenCpt, Init(R, Def));

VFenetre^.palette:=wpBluewindow;
VFenetre^.DragMode:=dmlimitLoy;
VFEnetre^.HelpCtx:= hcCptFen;

Desktop^.insert(ValidView(VFenetre));
end;


procedure TMyApp.NouvCpt;

var R:TRect;
    Def:TCptDef;
    NUM:string[3];
    C:PRadioButtons;
    B:PCheckBoxes;
    S:PCptInputLine;
    SS:PInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    NouvData:record
             Mode:word;
             Prev:word;
             LIB1:string[MAX_LG_LIB];
             LIB2:string[LgCre];
             LIB3:string[LgDeb];
             Nom:string[LG_NAME];
             end;
    NFIC:TNAME;
    X:ECatalog;
    V:PView;

begin
if not passwordOk then exit;

Stop:=false;
R.Assign(10,3,70,15);
Dialog:=New(PDialog,Init(R, 'Nouveau'));
with Dialog^ do
  begin
  helpctx:=hcCNouvBox;
  R.Assign(42,2,53,4);
  V:=(New (PButton, Init(R,'C~r~eer', cmok, bfDefault)));
  V^.HelpCtx:=hcCCreerBtn;
  insert(V);
  R.Assign(42,4,53,6);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);

  R.assign(2,4,25,7);
  C:=New(PRadioButtons, Init(R, NewSItem('~U~nique',
                                NewSItem('~M~ensuel',
                                NewSItem('~A~nnuel',
                                nil)))));
  C^.helpCtx:=hcCTypeU;
  insert(C);

  R.assign(30,6,50,7);
  B:=New(PCheckBoxes, Init(R, NewSItem('~P~rvision',
                              nil)));
  B^.HelpCtx:=hcCCasePrev;
  insert(B);

  R.Assign(2,9,28,10);
  SS:=New(PInputLine, Init(R,MAX_LG_LIB));
  SS^.helpCtx:=hcCLib;
  insert(SS);
  R.Assign(2,8,28,9);
  Insert(New(PLabel, Init(R, 'Libell ~1~ : ' , SS)));

  R.Assign(29,9,41,10);
  SS:=New(PInputLine, Init(R,LgCre));
  SS^.helpCtx:=hcCLib;
  insert(SS);
  R.Assign(29,8,41,9);
  Insert(New(PLabel, Init(R, 'Libell ~2~ : ' , SS)));

  R.Assign(44,9,56,10);
  SS:=New(PInputLine, Init(R,LgDeb));
  SS^.helpCtx:=hcCLib;
  insert(SS);
  R.Assign(44,8,56,9);
  Insert(New(PLabel, Init(R, 'Libell ~3~ : ' , SS)));


  R.Assign(12,2,35,3);
  S:=New(PCptInputLine, Init(R,1));
  S^.helpCtx:=hcCCptName;
  insert(S);
  R.Assign(2,2,11,3);
  Insert(New(PLabel, Init(R, '~C~ompte : ' , S)));


  NouvData.Mode:=0;
  NouvData.Prev:=0;
  str(NumSansNom,NUM);
  NouvData.Nom:=DEFAULT_NAME+NUM;
  inc(NumSansNom);
  NouvData.LIB1:=' LIBELLE ';
  NouvData.LIB2:=' CREDIT ';
  NouvData.LIB3:=' DEBIT  ';
  SetData(NouvData);
  Options:=Options or ofCentered;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(NouvData);

R.assign(20,5,60,12);
Dispose(Dialog,Done);

if stop then exit;

Def.Name:=NouvData.Nom;
Def.Prev:=false;
Def.Mois:=1;
Def.Annee:=1991;
if NouvData.Prev=0 then Def.Mode:=mdnorm else Def.Mode:=mdprev;
case NouvData.Mode of
  0:Def.Mode:=Def.Mode or mdseul;
  1:Def.Mode:=Def.Mode or mdmensuel;
  2:Def.Mode:=Def.Mode or mdannuel;
 end;


X.LIB1:=NouvData.LIB1;
X.LIB2:=NouvData.LIB2;
X.LIB3:=NouvData.LIB3;

MakeName(Def,NFIC,X);
end;

procedure TMyApp.ImporteCpt;

var R:TRect;
    NUM:string[3];
    C:PRadioButtons;
    S:PCptInputLine;
    SS:PInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    NouvData:record
             Mode:word;
             OldNom:string[80];
             Nom:string[LG_NAME];
             end;
    NFIC:TNAME;
    ok:boolean;
    V:PView;

begin
if not passwordOk then exit;
Stop:=false;
R.Assign(10,3,70,15);
Dialog:=New(PDialog,Init(R, 'Importe'));
with Dialog^ do
  begin
  R.Assign(42,2,53,4);
  V:=(New (PButton, Init(R,'C~o~pier', cmok, bfDefault)));
  V^.helpCtx:=hcCopierBtn;
  insert(V);
  R.Assign(42,4,53,6);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);

  R.assign(2,4,35,7);
  C:=New(PRadioButtons, Init(R, NewSItem('~G~nral',
                                NewSItem('~R~emboursement / Prt ',
                                NewSItem('~S~pciaux',
                                nil)))));
  C^.helpCtx:=hcCRadioG;
  insert(C);

  R.Assign(37,8,53,9);
  SS:=New(PInputLine, Init(R,80));
  SS^.helpCtx:=hcCImpName;
  insert(SS);
  R.Assign(2,8,37,9);
  Insert(New(PLabel, Init(R, 'Catalogue du compte  ~I~mporter : ' , SS)));

  R.Assign(12,2,35,3);
  S:=New(PCptInputLine, Init(R,2));
  S^.HelpCtx:=hcCCptName;
  insert(S);
  R.Assign(2,2,11,3);
  Insert(New(PLabel, Init(R, '~C~ompte : ' , S)));


  NouvData.Mode:=0;
  str(NumSansNom,NUM);
  NouvData.Nom:=DEFAULT_NAME+NUM;
  inc(NumSansNom);
  NouvData.OldNom:='';
  SetData(NouvData);
  Options:=Options or ofCentered;
  helpctx:=hcCImporBox;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(NouvData);

Dispose(Dialog,Done);

if stop then exit;

{ Vrifier validit du catalogue NouvData.oldNom }
if NouvData.OldNom[length(NouvData.OldNom)]<>'\' then
   NouvData.OldNom:=NouvData.OldNom+'\';

if not ImportRep(NouvData.OldNom) then
   begin
   R.Assign(5,7,75,14);
   Beep;
   MessageBoxRect(R,^C+'Pas de compte  importer dans ce Catalogue !',
    nil, mfError + mfOkButton);
   exit;
   end;

case NouvData.Mode of
  0:ok:=Importe_Annee(NouvData.OldNom,NouvData.Nom);
  1:ok:=Importe_remb(NouvData.OldNom,NouvData.Nom);
  2:ok:=Importe_Special(NouvData.OldNom,NouvData.Nom);
 end;

R.Assign(20,7,60,14);
if ok
 then MessageBoxRect(R,^C+'Traitement termin.',nil, mfInformation + mfOkButton)
 else MessageBoxRect(R,^C+'Compte dupliqu.',nil, mferror + mfOkButton);


end;




procedure TMyApp.InitMenuBar;

var
  R: TRect;
  LanceItems: PmenuItem;
  LanceNext: PmenuItem;
  LanceFic:Text;

begin
  GetExtent(R);
  R.B.Y := R.A.Y+1;
  MacNbLance:=0;
  LanceNext:=nil;
  assign(LanceFic,LANCE_FIC_NAME);
  {$I-}
  reset(LanceFic);
  {$I+}
  if ioresult= 0 then
  begin
    while not eof(LanceFic) do
    begin
      inc(MacNbLance);
      readln(LanceFic,MacLance[MacNbLance]);
      if MacLance[MacNbLance][1]='-' then
      begin
        dec(MacNbLance);
        LanceItems:= NewLine(LanceNext);
      end
      else
      begin
        LanceItems:= NewItem(MacLance[MacNbLance], '',kbNoKey, cmrun+MacNbLance, hcRun, LanceNext);
        readln(LanceFic,MacLance[MacNbLance]);
      end;
      LanceNext:=LanceItems;
    end;
    close(LanceFic);
  end
  else LanceItems:= NewItem('VIDE', '',kbNoKey, cmrun, hcRun, LanceNext);

  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~'#240'~', hcsystem, NewMenu(
      NewItem('~A~ propos...', '', kbNoKey, cmAbout, hcsabout,
      NewLine(
      NewItem('~C~alculatrice', 'F9',kbF9, cmcalculator, hcscalculator,
      NewItem('Ca~l~endrier', 'Alt-F9',kbAltF9, cmcalendar, hcscalendar,
      nil))))),
    NewSubMenu('~C~omptes', hccpt, NewMenu(
      NewItem('~O~uvrir', 'F3', kbF3, cmopen, hcCOpen,
      NewItem('~C~hanger', 'Alt-F3', kbAltF3, cmchanger, hcCchange,
      NewItem('~S~auver', 'F2', kbF2, cmCsave, hcCSave,
      NewItem('~N~ouveau', '', kbnokey, cmnouveau, hcCNouveau,
      NewItem('~T~ous Sauver', 'Alt-F2',kbAltF2, cmCsaveall, hcCSauvertous,
      NewLine(
      NewItem('~M~odifier', '', kbnokey, cmmodif, hcCModif,
      NewItem('~D~etruire', '', kbnokey, cmerase, hcCErase,
      NewItem('~P~roteger','',kbnokey, cmchgpass, hcCProtect,
      NewLine(
      NewItem('Change ~R~pertoire', '',kbNoKey, cmChangeDir, hcCchangedir,
      NewItem('~I~mporter','',kbnokey,cmimporte, hcCImporter,
      NewItem('Copier ~v~ers...', '',kbNoKey, cmCopycptto, hcCCopierVers,
      NewLine(
      NewItem('Accs au ~D~os', '',kbNoKey, cmDosShell, hcCDosShell,
      NewItem('~Q~uitter', 'Alt-X',kbAltX, cmquit, hcCExit,
      nil))))))))))))))))),
    NewSubMenu('~E~dition', hcEdit, NewMenu(
      NewItem('~C~opier','Ctrl-Ins', kbctrlins, cmcopy, hcEcopier,
      NewItem('Cou~p~er', 'Shift-Sup', kbshiftdel, cmcut, hcECouper,
      NewItem('Co~l~ler', 'Shift-Ins', kbshiftins, cmpaste, hcEColler,
      NewItem('~D~etruire', 'Ctrl-Sup', kbCtrlDel, cmdestroy, hcEDestroy,
      NewLine(
      NewItem('Copier Solde', 'Ctrl-F1', kbctrlF1, cmSoldeCopy, hcESolCop,
      NewItem('Copier Solde Slect', 'Ctrl-F2', kbCtrlF2, cmSoldeSCopy, hcESolSCop,
      NewLine(
      NewItem('~I~nverse presse-papier', '',kbNoKey, cminvpresspap, hcEinv,
      NewItem('~E~fface presse-papier', '',kbNoKey, cmclear, hcEeff,
      NewItem('~M~ontre presse-papier', 'F4',kbF4, cmshow, hcEMont,
      NewLine(
      NewItem('~A~joute ligne', '',kbNoKey, cmCnewline, hcEAjout,
      nil)))))))))))))),
    NewSubMenu('~I~mpression', hcPrint, NewMenu(
      NewItem('~I~mprime compte','Alt-F10', kbAltF10, cmprintdef, hcIPrint,
      NewItem('~B~ilan compte','', kbNoKey, cmbilancpt, hcIBilan,
      NewItem('Bilan par ~T~ype','', kbNoKey, cmtypbilancpt, hcITypBilan,
      NewLine(
      NewItem('~S~toppe impression','', kbNoKey, cmstopprint, hcIstopPrint,
      NewLine(
      NewItem('~C~hoix de l''imprimante','', kbNoKey, cmselprint, hcISelPrint,
      nil)))))))),
    NewSubMenu('~F~entres', hcwindow, NewMenu(
      NewItem('~D~uplique','Shift-F3', kbShiftF3, cmfenetre, hcwduplique,
      NewItem('~C~ascade','Alt-F5', kbaltf5, cmcascade, hcwcascade,
      NewItem('~M~osaique','Alt-F6', kbAltF6, cmtile, hcwTile,
      NewItem('~R~etaille/Bouge','CTRL-F5', kbCtrlF5, cmresize, hcwsizemove,
      NewItem('~Z~oom','F5', kbF5, cmzoom, hcwzoom,
      NewItem('~S~uivante','F6', kbF6, cmnext, hcwnext,
      NewItem('~P~rcdente','Shift-F6', kbshiftF6, cmprev, hcwprevious,
      NewItem('~F~erme','Alt-F4', kbAltF4, cmclose, hcwclose,
      nil))))))))),
    NewSubMenu('~O~ptions', hcoptions, NewMenu(
      NewItem('~S~ouris...','', kbNoKey, cmMouse, hcomouse,
      NewItem('~C~ouleurs...','', kbNoKey, cmcolors, hcocolors,
      NewItem('~M~ode vido', 'Alt-F7',kbaltf7, cmvideomode, hcovideo,
      NewItem('~B~ip...', '',kbNoKey, cmbeepmode, hcobip,
      NewItem('~P~rfrences', '',kbNoKey, cmpreferences, hcopref,
      NewItem('~T~ouches raccourcis', 'F7',kbF7, cmfastkey, hcoracc,
      NewItem('~T~ypes raccourcis', 'Shift-F1',kbCTRLF7, cmfasttyp, hcotyp,
      NewLine(
      NewItem('~E~nregistre Prfrences', '',kbNoKey, cmsavepref, hcOStore,
      NewItem('~R~echarge Prfrences', '',kbNoKey, cmloadpref, hcOLoad,
      nil))))))))))),
    NewSubMenu('O~u~tils', hcTools, NewMenu(
      NewItem('~C~lasser', '',kbNoKey, cmclass, hcTClass,
      NewItem('C~h~ercher', 'Alt-F8',kbAltF8, cmsearch, hcTSearch,
      NewLine(
      NewItem('~A~jouter alarme', '',kbNoKey, cmnewalarm, hcANouv,
      NewItem('~M~odifier alarme', '',kbNoKey, cmchangealarm, hcAModif,
      {$ifdef MACROON}
      NewLine(
      NewItem('Execute macro', 'CTRL-F8',kbCtrlF8, cmmacexec, hcMExec,
      NewItem('Edite macro ', 'SHIFT-F8',kbShiftF8, cmmacedit, hcMEdit,
      NewItem('Enregistre macro', 'SHIFT-F7',kbShiftF7, cmmacrec, hcMRec,
      NewItem('Termine macro', 'CTRL-F7',kbCtrlF7, cmmacendrec, hcMEnd,
      nil))))))))))),
      {$else}
      nil)))))),
      {$endif}
    NewSubMenu('~L~ancer', hcrun, NewMenu( LanceItems ),
    nil)))))))))));

end;

procedure TMyApp.EventError(var Event:TEvent);

begin
TApplication.EventError(Event);
if (Event.what=evcommand) and (Event.command=cmerror) then
   begin
   Beep;
   end;
end;

procedure TMyApp.DosShell(prg:string);

begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
  SetMemTop(HeapPtr);
  PrintStr('Frappez EXIT pour revenir  BUDGET ...');
  SwapVectors;
  if prg='' then Exec(GetEnv('COMSPEC'), '')
            else begin
                 prg:='/C '+prg;
                 Exec(GetEnv('COMSPEC'),prg);
                 end;
  SwapVectors;
  SetMemTop(HeapEnd);
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  SetVideoMode;
  LastEventTime:=timer;
  Redraw;
end;

procedure TMyApp.HandleEvent(var Event:TEvent);

procedure ChangeDir;
var
  D: PChDirDialog;
begin
  D := New(PChDirDialog, Init(cdNormal + cdHelpButton, 101));
  D^.HelpCtx := hcCCChdirDBox;
  if ValidView(D) <> nil then
  begin
    DeskTop^.ExecView(D);
    Dispose(D, Done);
  end;
end;

procedure Tile;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Tile(R);
end;

procedure Cascade;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Cascade(R);
end;

procedure Calendar;
var
  P: PCalendarWindow;
begin
  P := New(PCalendarWindow, Init);
  P^.HelpCtx := hcCalendrier;
  Desktop^.Insert(ValidView(P));
end;

procedure About;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
{$ifdef ROBECOM}
  R.Assign(0, 0, 70, 21);
  D := New(PDialog, Init(R, 'A propos...'));
  with D^ do
  begin
    Options := Options or ofCentered;
    helpctx:=hcSAbout;
    R.Grow(-1, -1);
    Dec(R.B.Y, 3);
    Insert(New(PStaticText, Init(R,
      #13 +
      ^C'VISION BUDGET - Version '+VER+REV+#13 +
      #13 +
      ^C'Auteur: Bory Patrick'+#13+
      #13 +
      ^C'COPYRIGHT (C) ROBECOM 1992'+
      #13 +
      ^C'Tous droits rservs.')));
    inc(R.A.Y,8);
    Insert(New(PStaticText, Init(R,
      ^C'L''utilisation de ce produit est soumise  la rglementation' +
      #13 +
      ^C'internationale sur les copyrights, et des poursuites seront'+
      #13 +
      ^C'engages pour toutes utilisations non conforme.')));
    inc(R.A.Y,4);
    Insert(New(PStaticText, Init(R,
      ^C'Avant d''utiliser ce logiciel, consulter les termes du contrats'+
      #13 +
      ^C'contenus dans le fichier licence, ou crivez  :'+
      #13 +
      ^C'ROBECOM B.P.30 34502 BEZIERS CEDEX FRANCE'
      )));
    R.Assign(30, 18, 40, 20);
    Insert(New(PButton, Init(R, 'O~K', cmOk, bfDefault)));
  end;
{$else}
  R.Assign(0, 0, 40, 13);
  D := New(PDialog, Init(R, 'A propos...'));
  with D^ do
  begin
    Options := Options or ofCentered;
    helpctx:=hcSAbout;
    R.Grow(-1, -1);
    Dec(R.B.Y, 3);
    Insert(New(PStaticText, Init(R,
      #13 +
      ^C'VISION BUDGET - Version '+VER+REV+#13 +
      #13 +
      ^C'N de srie: '+SERIAL_NUMBER+#13 +
      #13 +
      ^C'Gestion du budget familial'#13 +
      #13 +
      ^C'(C)1991-1995 Bory Patrick')));

    R.Assign(15, 10, 25, 12);
    Insert(New(PButton, Init(R, 'O~K', cmOk, bfDefault)));
  end;
{$endif}

  if ValidView(D) <> nil then
  begin
    Desktop^.ExecView(D);
    Dispose(D, Done);
  end;
end;

procedure Calculator;
var
  P: PCalculator;
begin
  P := New(PCalculator, Init);
  P^.HelpCtx := hccalculette;
  if ValidView(P) <> nil then
    Desktop^.Insert(P);
end;

procedure Colors;
var
  D: PColorDialog;
begin
  D := New(PColorDialog, Init('',
    ColorGroup('Bureau',
      ColorItem('Couleur',             32, nil),
    ColorGroup('Menus',
      ColorItem('Normal',            2,
      ColorItem('Inhib',          3,
      ColorItem('Raccourci',          4,
      ColorItem('Slection',          5,
      ColorItem('Slection inhibe', 6,
      ColorItem('Raccourci slectionn', 7, nil)))))),
    ColorGroup('Dialogues/Calc',
      ColorItem('Cadre/fond',  33,
      ColorItem('Cadre icne',       34,
      ColorItem('Barre dfil. page',   35,
      ColorItem('Barre dfil. icne',  36,
      ColorItem('Texte statique',       37,

      ColorItem('Label normal',      38,
      ColorItem('Label slect',    39,
      ColorItem('Label raccourci',    40,

      ColorItem('Bouton normal',     41,
      ColorItem('Bouton implicite',    42,
      ColorItem('Bouton slect',   43,
      ColorItem('Bouton inhib',   44,
      ColorItem('Bouton raccourci',   45,
      ColorItem('Bouton ombre',     46,

      ColorItem('Agrgat normal',    47,
      ColorItem('Agrgat slect',  48,
      ColorItem('Agrgat raccourci',  49,

      ColorItem('Saisie normal',      50,
      ColorItem('Saisie slection',    51,
      ColorItem('Saisie flche',       52,

      ColorItem('Historique bouton',    53,
      ColorItem('Historique sides',     54,
      ColorItem('Historique barre page',  55,
      ColorItem('Historique barre icne', 56,

      ColorItem('Liste normale',       57,
      ColorItem('Liste cible',      58,
      ColorItem('Liste slecte',     59,
      ColorItem('Liste sparateur',      60,

      ColorItem('Volet Information',  61, nil))))))))))))))))))))))))))))),
    ColorGroup('Fentre compte',
      ColorItem('Cadre passif',      8,
      ColorItem('Cadre actif',       9,
      ColorItem('Cadre icne',       10,
      ColorItem('Barre dfil. page',   11,
      ColorItem('Barre dfil. icne',  12,
      ColorItem('Texte normal',       13,
      ColorItem('Texte slectionn',  14, nil))))))),
    ColorGroup('Calendrier',
      ColorItem('Cadre passif',     16,
      ColorItem('Cadre actif',      17,
      ColorItem('Cadre icne',       18,
      ColorItem('Barre dfil. page',   19,
      ColorItem('Barre dfil. icne',  20,
      ColorItem('Texte normal',       21,
      ColorItem('Jour actuel',       22, nil))))))),
   ColorGroup('Aide',
      ColorItem('Cadre passif',     64,
      ColorItem('Cadre actif',      65,
      ColorItem('Cadre icne',       66,
      ColorItem('Barre dfil. page',   67,
      ColorItem('Barre dfil. icne',  68,
      ColorItem('Texte normal',       69,
      ColorItem('Texte slectionn',  70,
      ColorItem('Texte statique',       71, nil)))))))),
       nil))))))));

  D^.HelpCtx := hcOCcolorsDBox;
  if ValidView(D) <> nil then
  begin
    D^.SetData(Application^.GetPalette^);
    if Desktop^.ExecView(D) <> cmCancel then
    begin
      Application^.GetPalette^ := D^.Pal;
      DoneMemory;  { Dtruit tous les tampons cache de groupes }
      ReDraw;      { Raffiche l'application avec la nouvelle palette }
    end;
    Dispose(D, Done);
  end;
end;

procedure Mouse;
var
  D: PDialog;
begin
  D := New(PMouseDialog, Init);
  D^.HelpCtx := hcoMmouseDBox;
  if ValidView(D) <> nil then
  begin
    D^.SetData(MouseReverse);
    if Desktop^.ExecView(D) <> cmCancel then
      D^.GetData(MouseReverse);
  end;
end;

procedure SetPreferences;

var R:TRect;
    C:PCheckBoxes;
    P:PNumInputLine;
    Dialog:PDialog;
    Control:Word;
    BData:record
          Mode:word;
          SDelay:string[3];
          end;
    V:PView;
    Err:Integer;

begin
R.Assign(10,5,70,16);
Dialog:=New(PDialog,Init(R, 'Prfrences'));
with Dialog^ do
  begin
  helpctx:=hcOPrefBox;
  R.Assign(2,7,12,9);
  V:=(New (PButton, Init(R,' ~O~k', cmok, bfDefault)));
  V^.helpCtx:=hcCConfBtn;
  insert(V);
  R.Assign(15,7,28,9);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);

  R.assign(2,2,58,6);
  C:=New(PCheckBoxes, Init(R, NewSItem('Auto insertion de ~L~ignes',
                              NewSItem('Auto ~S~auvegarde',
                              NewSItem('~M~ode insertion',
                              NewSItem('~C~ontrle de dates',
                              NewSItem('Sauvegarde ~E~cran',
                              NewSItem('~P~aradise 132 cols',
                                nil))))))));
  C^.helpCtx:=hcOprefAl;
  insert(C);

  R.Assign(32,4,58,6);
  insert(New(PStaticText,Init(R,'')));

  R.assign(42,5,48,6);
  P:=New(PNumInputLine, Init(R,3,1,200,'Le delai d''attente doit tre entre 1 et 200'));
  P^.HelpCtx:=hcOPRefDs;
  R.Assign(34,5,56,6);
  Insert(New(PLabel, Init(R, '~D~lai: ' , P)));
  insert(P);


  BData.Mode:=0;
  if autoinsert then BData.Mode:=BData.Mode or 1;
  if autosavemode then BData.Mode:=BData.Mode or 2;
  if insertmode then BData.Mode:=BData.Mode or 4;
  if CheckDate then BData.Mode:=BData.Mode or 8;
  if VideoSave then BData.Mode:=BData.Mode or 16;
  if (videomode and 2)=2 then BData.Mode:=BData.Mode or 32;
  str(VideoSaveDelay,BData.SDelay);
  SetData(BData);
  Options:=Options or ofCentered;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then exit;
Dialog^.GetData(BData);

Dispose(Dialog,Done);

Autoinsert:=(BData.Mode and 1)=1;
AutosaveMode:=(BData.Mode and 2)=2;
InsertMode:=(BData.Mode and 4)=4;
CheckDate:=(BData.Mode and 8)=8;
videosave:=(BData.Mode and 16)=16;
val(BData.SDelay,videoSaveDelay,Err);
if ((BData.Mode and 32)=32) and ((VideoMode and 2)=0) then
   begin
   VideoMode:=VideoMode or 2;
   SetVideoMode;
   end;
if ((BData.Mode and 32)=0) and ((VideoMode and 2)=2) then
   begin
   VideoMode:=VideoMode xor 2;
   SetVideoMode;
   end;
end;

procedure SetprintPref;

var R:TRect;
    C:PRadioButtons;
    P:PNumInputLine;
    D:PCheckBoxes;
    Dialog:PDialog;
    Control:Word;
    BData:record
          Att:string[5];
          all:word;
          Form:word;
          end;
    ERR:integer;
    V:PView;

begin
R.Assign(12,5,68,16);
Dialog:=New(PDialog,Init(R, 'Prfrences Impression'));
with Dialog^ do
  begin
  helpctx:=hcIPrintBox;
  R.Assign(7,7,17,9);
  V:=(New (PButton, Init(R,' ~O~k', cmok, bfDefault)));
  V^.helpCtx:=hcOkPrintBtn;
  insert(V);
  R.Assign(30,7,43,9);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.HelpCtx:=hcCancelBtn;
  insert(V);

  R.Assign(44,5,50,6);
  P:=New(PNumInputLine, Init(R,5,0,65535,'Le temps d''attente doit tre entre 0 et 65535'));
  P^.HelpCtx:=hcItimeout;
  insert(P);

  R.Assign(30,5,43,6);
  Insert(New(PLabel, Init(R, '~A~ttente : ' , P)));


  R.assign(30,3,50,4);
  D:=New(PCheckBoxes, Init(R, NewSItem('~I~mprime tous',
                              nil)));
  d^.helpCtx:=hcIPrintAll;
  insert(D);

  R.assign(2,3,28,6);
  C:=New(PRadioButtons, Init(R, NewSItem('~N~ormal',
                                NewSItem('~C~arnet',
                                nil))));
  C^.helpCtx:=hcIForm;
  insert(C);
  R.Assign(2,2,32,3);
  insert( new(PLabel, Init(R, '~F~ormat d''impression', C)));

  str(Timeout,BData.Att);
  BData.Form:=Format;
  BData.all:=0;
  SetData(BData);
  Options:=Options or ofCentered;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then exit;
Dialog^.GetData(BData);

Dispose(Dialog,Done);

val(BData.Att,Timeout,ERR);
setprintmode(timeout<>0,timeout);
Format:=BData.Form;
EVENT.what:=evcommand;
EVENT.command:=cmprint;
if (BData.All and 1)=1 then EVENT.command:=cmprintall;
PutEvent(EVENT);
end;

procedure SetFastKey;

const ESP='                                                                ';

var R:TRect;
    L:PInputLine;
    Dialog:PDialog;
    Control:Word;
    BData:record
          Key:TFastKey;
          end;
    T:byte;
    V:PView;

begin
R.Assign(4,2,75,20);
Dialog:=New(PDialog,Init(R, 'Touches Raccourcis'));
with Dialog^ do
  begin
  R.Assign(47,15,60,17);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);
  R.Assign(27,15,40,17);
  V:=(New (PButton, Init(R,'Imprime', cmyes, bfNormal)));
  V^.helpCtx:=hcRaccImpBtn;
  insert(V);
  for T:=0 to 25 do
    begin
    if (T mod 2)=0 then R.Assign(13,(T div 2)+1,33,(T div 2)+2)
                   else R.Assign(49,(T div 2)+1,69,(T div 2)+2);
    L^.helpCtx:=hcnocontext;
    L:=new(PinputLine, Init(R,MAX_LG_LIB) );
    insert(L);
    R.A.X:=R.A.X-12;
    R.B.X:=R.A.X+12;
    insert( new(PLabel, Init(R, 'CTRL + ~'+chr(65+T)+'~ = ', L)));
    end;


  R.Assign(35,1,37,14);
  insert( new(PStaticText, Init(R, '                         ')));


  R.Assign(10,15,20,17);
  V:=(New (PButton, Init(R,' Ok', cmok, bfDefault)));
  V^.helpCtx:=hcCconfbtn;
  insert(V);
  BData.Key:=FastKey;
  SetData(BData);
  Options:=Options or ofCentered;
  helpctx:=hcORaccBox;
  end;

Control:=cmyes;
while Control=cmyes do
  begin
  Control:=DeskTop^.ExecView(Dialog);
  if Control=cmyes then
     begin
     Dialog^.GetData(BData);
     printcmd(prinit);
     printcmd(prCourrier);
     printcmd(pr10CPI);
     printcmd(prInterligne6);
     print('                         ');
     printcmd(prsouligne);
     println('Mmo des touches "raccourci"');
     printcmd(prfinsouligne);
     println('');
     printcmd(pr15CPI);
     printcmd(prInterligne8);
     print  (' ');
     println('Ŀ');
     for T:=0 to 12 do
       begin
       print  ('  CTRL + '+chr(65+T*2  )+' : '+copy(BData.Key[chr(T*2+1)]+ESP,1,42)     );
       println('  CTRL + '+chr(65+T*2+1)+' : '+copy(BData.Key[chr(T*2+2)]+ESP,1,42)+' ');
       if T<>12 then
         begin
         print  (' ');
         println('Ĵ');
         end;
       end;
     print  (' ');
     println('');
     println('');
     endpage;
     endprint;
     end;

  end;

if Control=cmcancel then exit;

Dialog^.GetData(BData);

Dispose(Dialog,Done);

FastKey:=BData.Key;
end;

procedure SetFastTyp;

const ESP='                                                                ';

var R:TRect;
    L:PInputLine;
    Dialog:PDialog;
    Control:Word;
    BData:record
          Key:TFastTyp;
          end;
    T:byte;
    V:PView;

begin
R.Assign(4,2,75,20);
Dialog:=New(PDialog,Init(R, 'Types Raccourcis'));
with Dialog^ do
  begin
  R.Assign(47,15,60,17);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);
  R.Assign(27,15,40,17);
  V:=(New (PButton, Init(R,'Imprime', cmyes, bfNormal)));
  V^.helpCtx:=hcRaccImpBtn;
  insert(V);
  for T:=0 to MAX_TYP-1 do
    begin
    if (T mod 2)=0 then R.Assign(13,(T div 2)+1,33,(T div 2)+2)
                   else R.Assign(49,(T div 2)+1,69,(T div 2)+2);
    L^.helpCtx:=hcnocontext;
    L:=new(PinputLine, Init(R,LgTyp) );
    insert(L);
    R.A.X:=R.A.X-12;
    R.B.X:=R.A.X+12;
    insert( new(PLabel, Init(R, '    ~'+chr(65+T)+'~   =  ', L)));
    end;


  R.Assign(35,1,37,14);
  insert( new(PStaticText, Init(R, '                         ')));


  R.Assign(10,15,20,17);
  V:=(New (PButton, Init(R,' Ok', cmok, bfDefault)));
  V^.helpCtx:=hcCconfbtn;
  insert(V);
  BData.Key:=FastTyp;
  SetData(BData);
  Options:=Options or ofCentered;
  helpctx:=hcOTypBox;
  end;

Control:=cmyes;
while Control=cmyes do
  begin
  Control:=DeskTop^.ExecView(Dialog);
  if Control=cmyes then
     begin
     Dialog^.GetData(BData);
     printcmd(prinit);
     printcmd(prCourrier);
     printcmd(pr10CPI);
     printcmd(prInterligne6);
     print('                         ');
     printcmd(prsouligne);
     println('Mmo des types "raccourci"');
     printcmd(prfinsouligne);
     println('');
     printcmd(pr15CPI);
     printcmd(prInterligne8);
     print  (' ');
     println('Ŀ');
     for T:=0 to ((MAX_TYP-1) div 2) do
       begin
       print  ('         '+chr(65+T*2+0)+' : '+copy(BData.Key[T*2+1]+ESP,1,42)     );
       println('         '+chr(65+T*2+1)+' : '+copy(BData.Key[T*2+2]+ESP,1,42)+' ');
       if T<>((MAX_TYP-1) div 2) then
         begin
         print  (' ');
         println('Ĵ');
         end;
       end;
     print  (' ');
     println('');
     println('');
     endpage;
     endprint;
     end;

  end;

if Control=cmcancel then exit;

Dialog^.GetData(BData);

Dispose(Dialog,Done);

FastTyp:=BData.Key;
end;


begin  { ------------ Debut De HANDLE EVENT ----------- }

  TApplication.HandleEvent(Event);

  case Event.What of
    evCommand:
      begin
        case Event.Command of
          cminvpresspap:InvPressPap;
          cmfenetre:Fenetre;
          cmopen:OpenCpt;
          cmnouveau: NouvCpt;
          cmmodif:ModifCpt;
          cmerase:EraseCpt;
          cmVideoMode:
            begin
            VideoMode := VideoMode xor 1;
            SetVideoMode;
            end;
          cmchangedir:changedir;
          cmpreferences:SetPreferences;
          cmDosShell:DosShell('');
          cmCalculator:Calculator;
          cmMouse:Mouse;
          cmColors:Colors;
          cmCalendar:Calendar;
          cmAbout:About;
          cmTile:tile;
          cmcascade:Cascade;
          cmbeepmode:SetBeepMode;
          cmimporte:ImporteCpt;
          cmchanger:FenetreDif;
          cmstopprint:stopall(True);
          cmprintdef:setprintpref;
          cmfastkey:setfastkey;
          cmfasttyp:setfasttyp;
          cmclear:VidePressPap;
          cmshow:OpenPressPap;
          cmsavepref:savepref;
          cmloadpref:loadpref;
          cmchgpass:ChangePassword;
          cmshowtotal:ShowTotal;
          cmnewalarm:NewAlarm;
          cmchangeAlarm:ChangeAlarm;
          cmcopycptto:CopyCptto;
          cmbilancpt:BilanCpt;
          cmtypbilancpt:TypBilanCpt;
          cmselprint:SelPrint;
          cmmacexec:macexec(0);
          cmmacedit:macedit;
          cmmacrec:macrec;
          cmmacendrec:macendrec;
          (cmrun+1)..(cmrun+MAX_MAC_LANCE):macexec(Event.Command-cmrun);
        else
          Exit;
        end;
        ClearEvent(Event);
      end;
  end;
end;

procedure TMyApp.NewAlarm;

var Al:PAlarmItem;

begin
Al:=InputAlarmItem;
if Al<>nil then Alrm.insert(Al);
AlrmStream^.Seek(0);
Alrm.store(AlrmStream^);
RepeatColl.Store(AlrmStream^);
end;


procedure TMyApp.ChangeAlarm;

var Al:PAlarmItem;

begin
Alrm.ModifAlarm;
AlrmStream^.Seek(0);
Alrm.store(AlrmStream^);
RepeatColl.Store(AlrmStream^);
end;

procedure TMyApp.CopyCptto;

var R,RR:TRect;
    DefS,DefD:TCptDef;
    C:PRadioButtons;
    S:PNumInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    CopData:record
            LSour:PStringCollection;
            NSour:Integer;
            LDest:PStringCollection;
            NDest:Integer;
            end;
    LSour,LDest:PStringCollection;
    Ch:PString;
    L:PListBox;
    V:PView;
    ScBar:PScrollBar;
    Name:TName;
    Cat:ECatalog;
    Res:String[4];
    CS,SCS:Real;
    prem,dern:boolean;

begin
if not PasswordOk then exit;

if message(Desktop,evbroadcast,cmfindcpt,@self)<>nil
 then begin
      Beep;
      R.Assign(10,5,70,12);
      MessageBoxRect(R,^C+'Fermer tous les comptes avant de lancer une copie !',
       nil, mferror + mfOkbutton);
      exit;
      end;

LSour:=new(PStringCollection,Init(10,1) );
LDest:=new(PStringCollection,Init(10,1) );
Stop:=not MakeList(LSour);
MakeList(LDest);

R.Assign(10,2,70,20);
Dialog:=New(PDialog,Init(R, 'Copie de compte vers compte'));

with Dialog^ do
  begin
  R.Assign(42,6,53,8);
  V:=(New (PButton, Init(R,'~C~opier', cmok, bfDefault)));
  V^.HelpCtx:=hcCCopBtn;
  insert(V);
  R.Assign(42,10,53,12);
  V:=(New (PButton, Init(R,'Annuler', cmcancel, bfNormal)));
  V^.helpCtx:=hcCancelBtn;
  insert(V);

  R.Assign(35,2,36,8);
  ScBar:=New(PScrollBar, Init(R));
  ScBar^.options:=ScBar^.options or ofpostprocess;
  insert(ScBar);
  R.Assign(2,2,35,8);
  L:=New(PListBox, Init(R,1,ScBar));
  L^.options:=L^.options or offramed;
  L^.HelpCtx:=hcCList;
  insert(L);
  R.Assign(2,1,6,2);
  Insert(New(PLabel, Init(R, '~D~e ' , L)));

  R.Assign(35,10,36,16);
  ScBar:=New(PScrollBar, Init(R));
  ScBar^.options:=ScBar^.options or ofpostprocess;
  insert(ScBar);
  R.Assign(2,10,35,16);
  L:=New(PListBox, Init(R,1,ScBar));
  L^.options:=L^.options or offramed;
  L^.HelpCtx:=hcCList;
  insert(L);
  R.Assign(2,9,8,10);
  Insert(New(PLabel, Init(R, '~V~ers ' , L)));

  CopData.LSour:=LSour;
  CopData.LDest:=LDest;
  CopData.NSour:=0;
  CopData.NDest:=0;
  SetData(CopData);
  Options:=Options or ofCentered;
  helpctx:=hcCCopierBox;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(CopData);


Dispose(Dialog,Done);

if (CopData.NSour=CopData.NDest) and (not stop) then
  begin
  stop:=true;
  Beep;
  R.assign(15,5,65,12);
  MessageBoxRect(R,^C+'Impossible de copier un compte sur lui mme !',
       nil, mferror + mfOkbutton);
  end;

if stop then begin
             dispose(LSour,Done);
             dispose(LDest,Done);
             exit;
             end;

DefS.Name:=STRING(LSour^.At(CopData.NSour)^);
DefD.Name:=STRING(LDest^.At(CopData.NDest)^);
Dispose(LSour,Done);
Dispose(LDest,Done);

DefS.Mois:=0;
DefS.Annee:=0;
DefS.Prev:=false;
DefD.Mois:=0;
DefD.Annee:=0;
DefD.Prev:=false;

MakeName(DefS,Name,cat);
MakeNAme(DefD,Name,cat);

if (DefS.Mode and mdannuel)=mdannuel then  { Annuel vers xxxx }
     begin
     beep;
     R.assign(10,5,70,12);
     MessageBoxRect(R,^C+'Impossible de copier un compte annuel sur un autre',
       nil, mferror + mfOkbutton);
     exit;
     end;

if (DefS.Mode and mdannuel)=mdmensuel then  { Mensuel vers xxxx }
   begin
   if (DefD.Mode and mdannuel)=mdannuel
     then begin
          R.Assign(10,1,16,2);
          S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
          S^.HelpCtx:=hcCCopAnnee;
          R.Assign(1,1,10,2);
          RR.Assign(0,0,18,3);
          Res:='';
          LabelInputBox(RR,S,New(PLabel, Init(R, '~A~nne : ' , S)),hcCCopAnnee,Res);
          if Res='' then exit;
          Val(Res,DefD.Annee,E);
          end
     else if (DefD.Mode and mdannuel)<>mdmensuel
            then begin
                 R.assign(5,5,75,12);
                 Beep;
                 MessageBoxRect(R,^C+'Impossible de copier un compte mensuel sur un compte unique !',
                   nil, mferror + mfOkbutton);
                 exit;
                 end;

   R.Assign(5,6,75,16);
   if CheckYear(DefD) then
     begin
     beep;
     if MessageBoxRect(R,^C+'Attention cette anne existe dja dans '+DefD.Name
                +#13+#13+^C+'  Destruction de l''anne ?',
                nil, mfWarning + mfYesButton+mfnoButton)<>cmyes then exit;
     end;

   for DefS.Mois:=1 to 12 do
     begin
     DefD.Mois:=DefS.Mois;
     DefS.Prev:=false;
     DefD.Prev:=false;
     Prem:=DefS.Mois=1;
     Dern:=(DefS.Mois=12) and ((DefD.Mode and mdprev)<>mdprev);
     CopyTo(DefS,DefD,CS,SCS,prem,dern);
     if (DefD.Mode and mdprev)=mdprev then
       begin
       DefS.Prev:=true;
       DefD.Prev:=true;
       Dern:=DefS.Mois=12;
       CopyTo(DefS,DefD,CS,SCS,false,dern);
       end;
     end;
   end;

if (DefS.Mode and mdannuel)=mdseul then   { Unique vers xxxx }
   begin
   if (DefD.Mode and mdannuel)=mdannuel
     then begin
          R.Assign(10,1,16,2);
          S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
          S^.HelpCtx:=hcCCopAnnee;
          R.Assign(1,1,10,2);
          RR.Assign(0,0,18,3);
          Res:='';
          LabelInputBox(RR,S,New(PLabel, Init(R, '~A~nne : ' , S)),hcCCopAnnee,Res);
          if Res='' then exit;
          Val(Res,DefD.Annee,E);
          Res:='';
          R.Assign(9,1,13,2);
          S:=New(PNumInputLine, Init(R, 2,1,12,^C+'Mois incorrect'));
          S^.HelpCtx:=hcCCopMois;
          R.Assign(1,1,8,2);
          RR.Assign(0,0,14,3);
          LabelInputBox(RR,S,New(PLabel, Init(R, '~M~ois : ' , S)),hcCCopMois,Res);
          if Res='' then exit;
          Val(Res,DefD.Mois,E);
          end
     else if (DefD.Mode and mdannuel)=mdmensuel
            then begin
                 Res:='';
                 R.Assign(9,1,13,2);
                 S:=New(PNumInputLine, Init(R, 2,1,12,^C+'Mois incorrect'));
                 S^.HelpCtx:=hcCCOpMois;
                 R.Assign(1,1,8,2);
                 RR.Assign(0,0,14,3);
                 LabelInputBox(RR,S,New(PLabel, Init(R, '~M~ois : ' , S)),hcCCopMois,Res);
                 if Res='' then exit;
                 Val(Res,DefD.Mois,E);
                 end;

   R.Assign(5,6,75,16);
   if checkMonth(DefD) then
    begin
    beep;
    if MessageBoxRect(R,^C+'Attention ce mois existe dja dans '+DefD.Name
                   +#13+#13+^C+'  Destruction du mois ?',
              nil, mfWarning + mfYesButton+mfnoButton)<>cmyes then exit;
    end;


   if (DefD.Mode and mdprev)=mdprev then
     begin
     DefS.Prev:=false;
     DefD.Prev:=false;
     CopyTo(DefS,DefD,CS,SCS,true,false);
     DefS.Prev:=true;
     DefD.Prev:=true;
     CopyTo(DefS,DefD,CS,SCS,false,true);
     end
    else
     begin
     DefS.Prev:=false;
     DefD.Prev:=false;
     CopyTo(DefS,DefD,CS,SCS,true,false);
     end;

   end;
R.assign(5,7,75,15);
MessageBoxRect(R,^C+'Copie de '+DefS.Name+' dans '+DefD.Name+' termine.',
   nil, mfInformation + mfOkButton);

end;

procedure TMyApp.BilanCpt;

var R:TRect;
    Def:TCptDef;
    C:PRadioButtons;
    S:PNumInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PDialog;
    Control:Word;
    BilData:record
            AnneeD,AnneeF:String[4];
            LCpt:PStringCollection;
            NCpt:Integer;
            end;
    LCpt:PStringCollection;
    Ch:PString;
    L:PListBox;
    V:PView;
    ScBar:PScrollBar;
    Name:TName;
    Cat:ECatalog;
    ADeb,AFin,MDeb,MFin,An,Mo,Jo,Js,Page:word;
    NUM:string[4];

begin
if not PasswordOk then exit;

if message(Desktop,evbroadcast,cmfindcpt,@self)<>nil
 then begin
      Beep;
      R.Assign(10,5,70,12);
      MessageBoxRect(R,^C+'Fermer tous les comptes avant de lancer un bilan !',
       nil, mferror + mfOkbutton);
      exit;
      end;

Page:=0;
repeat
LCpt:=new(PStringCollection,Init(10,1) );
Stop:=not MakeList(LCpt);

R.Assign(10,3,70,19);
Dialog:=New(PDialog,Init(R, 'Bilan'));
with Dialog^ do
  begin
  R.Assign(42,2,53,4);
  V:=(New (PButton, Init(R,'~I~mprime', cmok, bfDefault)));
  V^.HelpCtx:=hcIBImpBtn;
  insert(V);
  R.Assign(42,4,53,6);
  V:=(New (PButton, Init(R,'~T~ermine', cmcancel, bfNormal)));
  V^.helpCtx:=hcIBTermBtn;
  insert(V);

  R.Assign(47,9,53,10);
  S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
  S^.HelpCtx:=hcIBDep;
  insert(S);
  R.Assign(40,9,47,10);
  Insert(New(PLabel, Init(R, '~D~e : ' , S)));

  R.Assign(47,10,53,11);
  S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
  S^.HelpCtx:=hcIBFin;
  insert(S);
  R.Assign(40,10,47,11);
  Insert(New(PLabel, Init(R, '~A~  : ' , S)));

  R.Assign(35,3,36,14);
  ScBar:=New(PScrollBar, Init(R));
  ScBar^.options:=ScBar^.options or ofpostprocess;
  insert(ScBar);
  R.Assign(2,3,35,14);
  L:=New(PListBox, Init(R,1,ScBar));
  L^.options:=L^.options or offramed;
  L^.HelpCtx:=hcCList;
  insert(L);
  R.Assign(2,1,36,2);
  Insert(New(PLabel, Init(R, '~C~ompte : ' , L)));

  getdate(An,Mo,Jo,Js);
  Str(An:4,BilData.AnneeD);
  Str(An:4,BilData.AnneeF);

  BilData.LCpt:=LCpt;
  BilData.NCpt:=0;
  SetData(BilData);
  Options:=Options or ofCentered;
  helpctx:=hcIBBOx;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(BilData);

R.assign(20,5,60,12);

val(BilData.AnneeD,ADeb,E);
val(BilData.AnneeF,AFin,E);

Dispose(Dialog,Done);

if stop then begin
             dispose(LCpt,Done);
             if page<>0 then
                begin
                endpage;
                endprint;
                end;
             exit;
             end;

Def.Name:=STRING(LCpt^.At(BilData.NCpt)^);
Def.Prev:=false;
Def.Mois:=0;
Def.Annee:=0;

MakeName(Def,NAme,Cat);
MDeb:=1;
MFin:=1;
if (Def.Mode and mdmensuel)=mdmensuel then MFin:=12;
if (Def.Mode and mdannuel)<>mdannuel then AFin:=ADeb;

if page=0 then
         begin
         printcmd(prinit);
         printcmd(pr12CPI);
         Page:=1;
         str(Page,NUM);
         print('                                                                                      Page: '+NUM+#13);
         printcmd(pr10CPI);
         end;

if PrintedLines>57 then
         begin
         EndPage;
         printcmd(pr12CPI);
         Page:=Page+1;
         str(Page,NUM);
         print('                                                                                      Page: '+NUM+#13);
         printcmd(pr10CPI);
         end;

printcmd(prdoubhaut);
println(' Bilan du compte: '+Def.Name);
println('');
printcmd(prfindoubhaut);

for Def.Annee:=ADeb to AFin do
   for Def.Mois:=MDeb to MFin do
       begin
       if PrintedLines>58 then
         begin
         EndPage;
         Page:=Page+1;
         str(Page,NUM);
         printcmd(pr12CPI);
         print('                                                                                      Page: '+NUM+#13);
         printcmd(pr10CPI);
         end;
       Bilan(Def);
       end;

Dispose(LCpt,Done);
until false;
end;

procedure TMyApp.TypBilanCpt;

var R:TRect;
    Def:TCptDef;
    C:PRadioButtons;
    S:PNumInputLine;
    E:integer;
    Stop:Boolean;
    Dialog:PDialog;
    Cumul:boolean;
    Control:Word;
    BilData:record
            AnneeD,AnneeF:String[4];
            LCpt:PStringCollection;
            NCpt:Integer;
            Cumul:word;
            end;
    LCpt:PStringCollection;
    Ch:PString;
    L:PListBox;
    V:PView;
    ScBar:PScrollBar;
    Name:TName;
    Cat:ECatalog;
    ADeb,AFin,MDeb,MFin,An,Mo,Jo,Js,Page:word;
    NUM:string[4];
    fic:text;
    FileName: FNameStr;
    Rep,OldRep:string;
    PF:PFileDialog;
    NbTyp:integer;

begin
if not PasswordOk then exit;

if message(Desktop,evbroadcast,cmfindcpt,@self)<>nil
 then begin
      Beep;
      R.Assign(10,5,70,12);
      MessageBoxRect(R,^C+'Fermer tous les comptes avant de lancer un bilan !',
       nil, mferror + mfOkbutton);
      exit;
      end;

Page:=0;
getdir(0,OldRep);
FileName := 'BILAN.TXT';
PF:=New(PFileDialog, Init('*.TXT', 'Bilan par type',
         '~N~om ficher bilan', fdOpenButton+fdHelpButton, 100));
PF^.HelpCtx:=hcnocontext;
if ExecDialog(PF,@FileName) = cmCancel
 then exit
 else begin
      FileName:=Fexpand(FileName);
      assign(Fic,FileName);
      {$I-}
      rewrite(Fic);
      {$I+}
      if ioresult<>0 then
        begin
        MessageBox('Impossible de crer le fichier '+FileName, nil, mfError + mfOkButton);
        exit;
        end;
      end;
chdir(OldRep);
repeat
LCpt:=new(PStringCollection,Init(10,1) );
Stop:=not MakeList(LCpt);

R.Assign(10,3,70,19);
Dialog:=New(PDialog,Init(R, 'Bilan par type'));
with Dialog^ do
  begin
  R.Assign(42,2,53,4);
  V:=(New (PButton, Init(R,' ~L~ance ', cmok, bfDefault)));
  V^.HelpCtx:=hcITBImpBtn;
  insert(V);
  R.Assign(42,4,53,6);
  V:=(New (PButton, Init(R,'~T~ermine', cmcancel, bfNormal)));
  V^.helpCtx:=hcITBTermBtn;
  insert(V);

  R.Assign(47,9,53,10);
  S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
  S^.HelpCtx:=hcIBDep;
  insert(S);
  R.Assign(40,9,47,10);
  Insert(New(PLabel, Init(R, '~D~e : ' , S)));

  R.Assign(47,10,53,11);
  S:=New(PNumInputLine, Init(R, 4,1900,3000,^C+'Anne incorrecte'));
  S^.HelpCtx:=hcIBFin;
  insert(S);
  R.Assign(40,10,47,11);
  Insert(New(PLabel, Init(R, '~A~  : ' , S)));

  R.Assign(35,3,36,14);
  ScBar:=New(PScrollBar, Init(R));
  ScBar^.options:=ScBar^.options or ofpostprocess;
  insert(ScBar);
  R.Assign(2,3,35,14);
  L:=New(PListBox, Init(R,1,ScBar));
  L^.options:=L^.options or offramed;
  L^.HelpCtx:=hcCList;
  insert(L);
  R.Assign(2,1,36,2);
  Insert(New(PLabel, Init(R, '~C~ompte : ' , L)));

  R.assign(40,13,53,14);
  V:=New(PCheckBoxes, Init(R, NewSItem('~C~umul',
                              nil)));
  V^.HelpCtx:=hcITBCumul;
  insert(V);

  getdate(An,Mo,Jo,Js);
  Str(An:4,BilData.AnneeD);
  Str(An:4,BilData.AnneeF);

  BilData.LCpt:=LCpt;
  BilData.NCpt:=0;
  BilData.Cumul:=0;
  SetData(BilData);
  Options:=Options or ofCentered;
  helpctx:=hcITBBox;
  end;

Control:=DeskTop^.ExecView(Dialog);

if Control=cmcancel then Stop:=True;
Dialog^.GetData(BilData);

R.assign(20,5,60,12);

val(BilData.AnneeD,ADeb,E);
val(BilData.AnneeF,AFin,E);
Cumul:=BilData.Cumul=1;

Dispose(Dialog,Done);

if stop then begin
             dispose(LCpt,Done);
             close(fic);
             exit;
             end;

Def.Name:=STRING(LCpt^.At(BilData.NCpt)^);
Def.Prev:=false;
Def.Mois:=0;
Def.Annee:=0;

MakeName(Def,NAme,Cat);
MDeb:=1;
MFin:=1;
if (Def.Mode and mdmensuel)=mdmensuel then MFin:=12;
if (Def.Mode and mdannuel)<>mdannuel then AFin:=ADeb;

writeln(fic,'Bilan du compte: '+Def.Name);
writeln(fic,'');

nbtyp:=0;

for Def.Annee:=ADeb to AFin do
   for Def.Mois:=MDeb to MFin do
       begin
       if (Def.Mode and mdprev)=mdprev then
          begin
          if not cumul then nbtyp:=0;
          Def.Prev:=false;
          TypBilan(Def,fic,nbtyp,cumul); { Pour l'instant dtail si cumul }
          Def.Prev:=true;
          TypBilan(Def,fic,nbtyp,true);
          end
       else
          begin
          if not cumul then nbtyp:=0;
          Def.Prev:=false;
          TypBilan(Def,fic,nbtyp,true);
          end;
       end;

Dispose(LCpt,Done);
until false;
end;


procedure TMyApp.InitstatusLine;

var R:Trect;

begin
GetExtEnt(R);
R.A.Y:=R.B.Y-1; { Position de l'elvis=derniere ligne }
StatusLine:=new(PHintStatusLine, Init(R,
   NewStatusDef(hcCptFen,hcCptFen,
     NewStatuskey('~F1~ Aide',kbf1, cmhelp,
     NewStatuskey('',kbAltX, cmquit,
     NewStatuskey('~Alt-F3~ Changer', kbAltF3,cmchanger,
     NewStatuskey('~Alt-F4~ Fermer', kbAltF4,cmclose,
     NewStatuskey('', kbCtrlF9,cmDebZone,
     NewStatuskey('', kbCtrlF10,cmEndZone,
     NewStatuskey('~F8~ Libere', kbF8,cmClearZone,
     NewStatuskey('', kbShiftF9,cmDebLZone,
     NewStatuskey('', kbShiftF10,cmEndLZone,
     NewStatuskey('', kbAltF1,cmShowTotal,
     NewStatusKey('~F10~ Menu', kbF10, cmMenu,
     nil))))))))))),
   NewStatusDef(0,0,
     NewStatuskey('~F1~ Aide',kbf1, cmhelp,
     NewStatuskey('~Alt-X~ Quitter',kbAltX, cmquit,
     NewStatuskey('~Alt-F4~ Fermer', kbAltF4,cmclose,
     NewStatusKey('~F10~ Menu', kbF10, cmMenu,
     nil)))),
   NewStatusDef(hcdragging,hcdragging,
     NewStatuskey('~'+#24+#25+#26+#27+'~ Dplace',kbf1, cmhelp,
     NewStatuskey('~Shift-'+#24+#25+#26+#27+'~ Retaille',kbnokey, cmhelp,
     NewStatuskey('~'+#17+' Valide', kbnokey,cmhelp,
     NewStatusKey('~Esc~ Abandonne', kbF10, cmHelp,
     nil)))),
   NewStatusDef(0,$FFFF,
     NewStatuskey('~F1~ Aide',kbf1, cmhelp,
     NewStatusKey('', kbF10, cmMenu,
     nil)),
   nil))))));

end;

destructor TMyApp.done;

begin
AlrmStream^.Seek(0);
Alrm.store(AlrmStream^);
RepeatColl.Store(AlrmStream^);
Dispose(AlrmStream,done);
TApplication.done;
end;

procedure TMyApp.SelPrint;

var FileName: FNameStr;
    Rep,OldRep:string;
    PF:PFileDialog;

begin

  getdir(0,OldRep);
  chdir(CalcExeRep);
  FileName := PrintDriver;
  PF:=New(PFileDialog, Init('*.drv', 'Choix du driver imprimante',
           '~D~river', fdOpenButton+fdHelpButton, 100));
  PF^.HelpCtx:=hcISelPrintBox;
  if ExecDialog(PF,@FileName) <> cmCancel then PrintDriver:=Fexpand(FileName);
  chdir(OldRep);

end;


procedure TMyapp.MacExec(auto:byte);

var FileName: FNameStr;
    Rep,OldRep:string;
    PF:PFileDialog;
    R:word;

begin
if MacOn then exit;
DrawOn:=true;
ForceAnnee:=0;
ForceMois:=0;
ForcePrev:=false;
ForceOpen:='';
MacTexte:='';
MacPause:=false;
MacLigne:=1;
MacGosub[0]:=0;
getdir(0,OldRep);
if auto=0 then
begin
  FileName := MacName;
  PF:=New(PFileDialog, Init('*.MAC', 'Execute Macro',
         '~N~om macro', fdOpenButton+fdHelpButton, 100));
  PF^.HelpCtx:=hcnocontext;
  R:=ExecDialog(PF,@FileName);
end else
begin
  R:=cmok;
  FileName := MacLance[auto];
end;
if R <> cmCancel
 then begin
      MacName:=Fexpand(FileName);
      assign(MacFic,MacName);
      {$I-}
      reset(MacFic);
      {$I+}
      if ioresult= 0 then MacRead:=true
                     else if auto<>MAX_MAC_LANCE
                            then MessageBox('Impossible d''ouvrir le fichier '+MacName, nil, mfError + mfOkButton);
      end;
chdir(OldRep);
end;


procedure TMyapp.MacEdit;


var FileName: FNameStr;
    Rep,OldRep,EditorName:string;
    PF:PFileDialog;

begin
if MacOn then exit;
getdir(0,OldRep);
FileName := MacName;
PF:=New(PFileDialog, Init('*.MAC', 'Edite Macro',
         '~N~om macro', fdOpenButton+fdHelpButton, 100));
PF^.HelpCtx:=hcnocontext;

if GetEnv(VBUDEDITOR)<>'' then EditorName:=getenv(VBUDEDITOR)
                          else EditorName:=DEFAULT_EDITOR;

if ExecDialog(PF,@FileName) <> cmCancel
 then begin
      MacName:=Fexpand(FileName);
      DoneSysError;
      DoneEvents;
      DoneVideo;
      DoneMemory;
      SetMemTop(HeapPtr);
      PrintStr('Lancement de l''diteur ...');
      SwapVectors;
      Exec(GetEnv('COMSPEC'), '/c '+EditorName+' '+MacName);
      SwapVectors;
      SetMemTop(HeapEnd);
      InitMemory;
      InitVideo;
      InitEvents;
      InitSysError;
      SetVideoMode;
      LastEventTime:=timer;
      Redraw;
      end;
chdir(OldRep);
end;

procedure TMyapp.MacRec;

var FileName: FNameStr;
    Rep,OldRep:string;
    PF:PFileDialog;


begin
if MacOn then exit;
getdir(0,OldRep);
FileName := MacName;
PF:=New(PFileDialog, Init('*.MAC', 'Enregistre Macro',
         '~N~om macro', fdOpenButton+fdHelpButton, 100));
PF^.HelpCtx:=hcnocontext;
if ExecDialog(PF,@FileName) <> cmCancel
 then begin
      MacName:=Fexpand(FileName);
      assign(MacFic,MacName);
      {$I-}
      rewrite(MacFic);
      {$I+}
      if ioresult= 0 then MacOn:=true
                     else MessageBox('Impossible de crer le fichier '+MacName, nil, mfError + mfOkButton);
      end;
chdir(OldRep);
end;


procedure TMyapp.MacEndRec;

begin
if not Macon then exit;

close(MacFic);
MacOn:=false;
end;



var
  MyApp: TMyApp;
  EXEName:string;
  OldDir:string;
  i:byte;
  Locker:File;

begin
  MacOn:=false;
  MacRead:=false;
  MacName:='';
  MacTexte:='';
  MacPause:=false;
  MacLigne:=0;
  MacGosub[0]:=0;
  ForceAnnee:=0;
  ForceMois:=0;
  ForcePrev:=false;
  ForceOpen:='';
  DrawOn:=true;
  For i:=1 to MAX_MAC_VAR do MacVar[i]:='';
  if getEnv(VBUDEXE)<>'' then
    if FSearch(PRG_NAME,getEnv(VBUDEXE))='' then
       begin
       writeln(' Impossible de trouver ',PRG_NAME);
       writeln(' Rpertoire "',GetEnv(VBUDEXE),'" incorrect dans ',VBUDEXE,'.');
       halt(1);
       end;
  assign(Locker,CalcExeRep+'\'+LOCKFILE);
  {$I-}
  rewrite(Locker);
  {$I+}
  if ioresult<>0 then
       begin
       writeln(' La licence de VBUDGET est dja en cours d''utilisation !');
       sound(4000);
       delay(2000);
       nosound;
       halt(1);
       MyApp.Done;
       end;
  close(Locker);

  {$I-}
  getdir(0,OldDir);
  if GetEnv(VBUDCPT)<>'' then chdir(getenv(VBUDCPT));
  if ioresult<>0 then
    begin
    writeln(' Rpertoire "',GetEnv(VBUDCPT),'" incorrect dans ',VBUDCPT,'.');
    halt(1);
    end;

  if paramcount>=1 then chdir(paramstr(1));
  {$I+}
  if ioresult<>0 then
    begin
    writeln(' Rpertoire "',paramstr(1),'" incorrect dans 2me paramtre.');
    halt(1);
    end;

  { Contexte d'aide de l'unit beep }
  hbdialog:=hcOBipBox;
  hbok:=hcCconfbtn;
  hbcancel:=hccancelbtn;
  hbtest:=hctestBeepbtn;
  hbtype:=hcnocontext;
  hbinst:=hcnocontext;


  haCancelBtn:=hcCancelBtn;
  haOkBtn:=hcAOkBtn;
  haRadioBtn:=hcARadioBtn;
  haAnneeAlarm:=hcAAnnee;
  haJourAlarm:=hcAJour;
  haheureAlarm:=hcAHeure;
  haminutalarm:=hcAMinute;
  haMessage:=hcAMessage;
  haAlarmBox:=hcANouvBox;
  hasuivantBtn:=hcASuivantBtn;
  hadetruitBtn:=hcADetruitBtn;
  haMAlarmBox:=hcAModifBox;
  MyApp.Init;
  assign(Locker,CalcExeRep+'\'+LOCKFILE);
  {$I-}
  rewrite(Locker);
  {$I+}
  if ioresult<>0 then
       begin
       writeln(' La licence de VBUDGET est dja en cours d''utilisation !');
       sound(4000);
       delay(2000);
       nosound;
       halt(1);
       MyApp.Done;
       end;
  MacLance[MAX_MAC_LANCE]:='AUTORUN.MAC';
  MyApp.MacExec(MAX_MAC_LANCE);
  MyApp.Run;
  MyApp.Done;
  CptList.done; { Libre l'espace attribu pour l'unit compte }
  ChDir(OldDir);
  close(Locker);
end.
