
function GetCmdNumber(S:string):integer;  { Retourne le n de commande associ  S }

var f:byte;
    N,ERR:integer;

begin
N:=-1;
for f:=1 to length(S) do S[f]:=upcase(S[f]);
if pos(' ',S)<>0 then S[0]:=chr((pos(' ',S)-1));
for f:=1 to MAXCMD do if S=CMD[f].S then N:=CMD[f].N;
if N=-1 then val(S,N,ERR);
GetCmdNumber:=N;
end;

function GetCmdName(N:integer):string;  { Retourne le nom de commande associ  N }

var f:byte;
    S:string;

begin
S:='';
for f:=1 to MAXCMD do if N=CMD[f].N then S:=CMD[f].S;
if S='' then str(N,S);
GetCmdName:=S;
end;




constructor TSoftMouse.Init;

var R:Trect;

begin
R.Assign(0,0,1,1);
Options:=0;
TView.Init(R);
end;

procedure TSoftMouse.Draw;

var B:TDrawBuffer;
    C:Byte;

begin
C:=GetColor(2);
Movechar(B,#24,C,size.X);
Writeline(0,0,Size.X,1,B);
end;


procedure StrUpCase(var S:String);

var i:byte;

begin
for i:=1 to length(S) do S[i]:=upcase(S[i]);
end;

function CalcHelpName: PathStr;
var
  EXEName: PathStr;
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
begin
  if Lo(DosVersion) >= 3 then EXEName := ParamStr(0)
  else EXEName := FSearch(PRG_NAME, GetEnv('PATH'));
  FSplit(EXEName, Dir, Name, Ext);
  if getEnv(VBUDEXE)<>'' then dir:=getEnv(VBUDEXE);
  if Dir[Length(Dir)] = '\' then Dec(Dir[0]);

  CalcHelpName := FSearch(HELP_NAME, Dir);
end;

function CalcExeRep: PathStr;
var
  EXEName: PathStr;
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
begin
  if Lo(DosVersion) >= 3 then EXEName := ParamStr(0)
  else EXEName := FSearch(PRG_NAME, GetEnv('PATH'));
  FSplit(EXEName, Dir, Name, Ext);
  if getEnv(VBUDEXE)<>'' then dir:=getEnv(VBUDEXE);
  if Dir[Length(Dir)] = '\' then Dec(Dir[0]);
  CalcExeRep:=Dir;
end;

function CalcPrefName: DirStr;
var
  EXEName: PathStr;
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
begin
  if Lo(DosVersion) >= 3 then EXEName := ParamStr(0)
  else EXEName := FSearch(PRG_NAME, GetEnv('PATH'));
  FSplit(EXEName, Dir, Name, Ext);
  if getEnv(VBUDCONF)<>'' then Dir:=GetEnv(VBUDCONF);
  if paramcount>=1 then Dir:=paramstr(1);

  if Dir[Length(Dir)] = '\' then Dec(Dir[0]);
  CalcPrefName := Dir+'\'+CONFIG_NAME;
end;



procedure TModifDialog.HandleEvent(var E:TEvent);

var ModifData:TModifData;
    Info:ECatalog;
    Cpt:TCptDef;
    NFIC:TNAME;

begin
if (E.what=evbroadcast) and
   (E.command=cmItemFocused) then

   begin
   getData(ModifData);

   ModifData.Nom:=STRING(ModifData.LCpt^.At(ModifData.NCpt)^);
   Cpt.Name:=ModifData.Nom;
   MakeName(Cpt,NFIC,Info);
   if (Cpt.Mode and mdprev)=mdprev then ModifData.Prev:=1 else ModifData.Prev:=0;
   ModifData.mode:=0;
   if (Cpt.Mode and mdmensuel)=mdmensuel then ModifData.Mode:=ModifData.Mode+1;
   if (Cpt.Mode and mdannuel)=mdannuel then ModifData.Mode:=ModifData.Mode+1;

   ModifData.LIB1:=Info.Lib1;
   ModifData.LIB2:=Info.Lib2;
   ModifData.LIB3:=Info.Lib3;
   ModeBtn^.setData(ModifData.Mode);
   ModeBox^.setData(ModifData.Prev);
   NameLine^.OkName:=ModifData.Nom;
   NameLine^.setData(ModifData.Nom);
   Lib1Line^.setData(ModifData.LIB1);
   Lib2Line^.setData(ModifData.LIB2);
   Lib3Line^.setData(ModifData.LIB3);
   end;

TDialog.HandleEvent(E);
end;

function TModifDialog.Valid(cm:word):boolean;

 var Ok:boolean;
     R:TRect;
     LG:Byte;
     ModifData:TModifData;
     Info:ECatalog;
     Cpt:TCptDef;
     NFIC:TNAME;
     OldMode:word;

begin
  Ok:=TDialog.Valid(cm);

  Valid:=Ok;

  if cm=cmcancel then exit;

   R.assign(20,7,60,14);
   getData(ModifData);

   Cpt.Name:=STRING(ModifData.LCpt^.At(ModifData.NCpt)^);
   MakeName(Cpt,NFIC,Info);
   if ((Cpt.Mode and mdprev)=mdprev) and (ModifData.prev<>1) and OK then
     begin
     Beep;
     MessageBoxRect(R,^C+'Impossible de supprimer les prvisions',
       nil, mfError + mfOkButton);
     Ok:=false;
     end;

   Oldmode:=0;
   if (Cpt.Mode and mdmensuel)=mdmensuel then OldMode:=OldMode+1;
   if (Cpt.Mode and mdannuel)=mdannuel then OldMode:=OldMode+1;

  if (OldMode<>ModifData.Mode) and OK then
    begin
    Beep;
    R.assign(20,7,60,14);
    MessageBoxRect(R,^C+'Impossible de modifier le mode',
     nil, mfError + mfOkButton);
    Ok:=false;
    end;

  Valid:=Ok;
end;


function THintStatusLine.Hint(Ctx:word):string;


begin
Hint:='';
case Ctx of
  hcANouv        : Hint:=' Ajoute une nouvelle alarme';
  hcAModif       : Hint:=' Modifie une alarme';
  hcARadioBtn    : Hint:=' Alarme ponctuelle';
  hcARadioBtn2   : Hint:=' Alarme rpte tous les mois';
  hcARadioBtn3   : Hint:=' Alarme rpte tous les ans';
  hcAAnnee       : Hint:=' Entrez l''anne de dclenchement';
  hcAMois        : Hint:=' Entrez le mois de dclenchement';
  hcAJour        : Hint:=' Entrez le jour de dclenchement';
  hcAHeure       : Hint:=' Entrez l''heure de dclenchement';
  hcAMinute      : Hint:=' Entrez les minutes de l''heure de  dclenchement';
  hcAMessage     : Hint:=' Entrez le message  afficher lors du dclenchement';
  hcASuivantBtn  : Hint:=' Modifie l''alarme suivante';
  hcADetruitBtn  : Hint:=' Dtruit dfinitivement l''alarme courante';
  hcCancelBtn    : Hint:=' Ferme la fentre sans rien faire';
  hcCAnneeOpen   : Hint:=' Entrez l''anne sur 4 chiffres';
  hcCCasePrev    : Hint:=' Slectionnez cette case pour le type prvision';
  hcCChange      : Hint:=' Change de mois/anne/Mode.';
  hcCChangerBtn  : Hint:=' Ouvre le mois ainsi dcrit.';
  hcCChangeDir   : Hint:=' Change de rpertoire';
  hcCopierBtn    : Hint:=' Lance l''importation du compte';
  hcCCopierVers  : Hint:=' Copie un compte (unique/Mensuel) dans un autre compte';
  hcCCopBtn      : Hint:=' Lance la copie du compte';
  hcCCptName     : Hint:=' Entrez le nom du compte';
  hcCCreerBtn    : Hint:=' Cre le compte ainsi dcrit';
  hcCDosShell    : Hint:=' Excute le Shell du DOS';
  hcCExit        : Hint:=' Quitte Vision Budget et retourne au Dos';
  hccErase       : Hint:=' Dtruit un compte';
  hcCEraseBtn    : Hint:=' Lance la destruction du compte';
  hcCImporter    : Hint:=' Importe un compte d''une version prcdente';
  hccImpName     : Hint:=' Entrez le catalogue o se trouvent les comptes';
  hcCLib         : Hint:=' Entrez le libell de la colonne';
  hcCList        : Hint:=' Choisissez un compte dans la liste';
  hcCMoisopen    : Hint:=' Entrez le mois entre 1 et 12';
  hcCModif       : Hint:=' Modifie les attributs d''un compte';
  hcCModifBtn    : Hint:=' Modifie les attributs du compte ainsi dcrit';
  hcCNouveau     : Hint:=' Cre un nouveau compte';
  hcCOpen        : Hint:=' Ouvre un compte existant';
  hcCOpenBtn     : Hint:=' Ouvre le mois ainsi dcrit.';
  hcCCopAnnee    : Hint:=' Choisissez l''anne o la copie doit tre faite.';
  hcCCopMois     : Hint:=' Choisissez le mois o la copie doit tre faite.';
  hcCProtect     : Hint:=' Change le mot de passe du rpertoire courant';
  hcCPassentry   : Hint:=' Entrez le mot de passe';
  hcOkPrintBtn   : Hint:=' Lance l''impression';
  hcOprefAl      : Hint:=' Active/dsactive l''insertion de ligne en fin de compte';
  hcOprefAs      : Hint:=' Active/dsactive la sauvegarde automatique des comptes';
  hcOprefMi      : Hint:=' Active/dsactive le mode insertion (des caractres)';
  hcOprefCd      : Hint:=' Active/dsactive la vrification des dates entres';
  hcOPrefSe      : Hint:=' Active/Dsactive la coupure automatique de l''cran.';
  hcOPrefPa      : Hint:=' Active/Dsactive la mode 132 colonnes des cartes PARADISE';
  hcOPrefDs      : Hint:=' Entrez le dlai avant coupure cran, en demi-minutes';
  hcCpt          : Hint:=' Effectue une opration sur un compte: Ouvrir, Sauver,...';
  hcCRadioG      : Hint:=' Importe la comptabilit gnrale';
  hcCRadioR      : Hint:=' Importe les Remboursements/Prts';
  hcCRadioS      : Hint:=' Importe les mois spciaux';
  hcCRadioN      : Hint:=' Slectionne le mode Normal';
  hcCRadioP      : Hint:=' Slectionne le mode Prvision';
  hcCSauvertous  : Hint:=' Sauve tous les comptes ouverts';
  hcCsave        : Hint:=' Sauve le compte courant';
  hcEAjout       : Hint:=' Ajoute une ligne  la fin du compte';
  hcEColler      : Hint:=' Colle le contenu du presse-papier dans le compte courant';
  hcESolCop      : Hint:=' Copie le solde dans le presse-papier';
  hcESolSCop     : Hint:=' Copie le solde avec slecteur dans le presse-papier';
  hcECopier      : Hint:=' Copie la slection dans le presse-papier';
  hcECouper      : Hint:=' Copie dans le presse-papier et supprime la slection';
  hcEDestroy     : Hint:=' Supprime  la slection (SANS COPIER dans le presse-papier)';
  hcEdit         : Hint:=' Modifie le contenu d''un compte: Copier, Coller, ...';
  hcEEff         : Hint:=' Efface le presse-papier';
  hcEInv         : Hint:=' Inverse les colonnes DEBIT<->CREDIT du presse-papier';
  hcEMont        : Hint:=' Affiche le presse-papier';
  hcIBilan       : Hint:=' Imprime un bilan pour un ou plusieurs comptes';
  hcIBImpBtn     : Hint:=' Imprime le bilan du compte slectionn';
  hcIBtermBtn    : Hint:=' Quitte la boite de dialogue et lence l''impression';
  hcITypBilan    : Hint:=' Cre un fichier bilan par type pour un ou plusieurs comptes';
  hcITBImpBtn    : Hint:=' Lance le bilan du compte slectionn';
  hcITBtermBtn   : Hint:=' Quitte la boite de dialogue et cre le fichier bilann';
  hcIBDep        : Hint:=' Entrez l''anne de dbut du bilan';
  hcIBFin        : Hint:=' Entrez l''anne de fin du bilan';
  hcIPrint       : Hint:=' Imprime un ou plusieurs comptes';
  hcIPrintAll    : Hint:=' Active/Dsactive l''impression de tous les comptes ouverts';
  hcIPrintbox    : Hint:=' Dfinition des paramtres d''impression';
  hcISelPrint    : Hint:=' Slectionne le driver pour votre imprimante';
  hcIStopPrint   : Hint:=' Stoppe toute impression en cours.';
  hcIForm        : Hint:=' Slectionne le format d''impression';
  hcItimeout     : Hint:=' Dlai d''attente (en centime de secondes)';
  hcOBip         : Hint:=' Dfinit le type de bip sonore ou supprime le bip sonore';
  hcOBipBox      : Hint:=' Slectionnez le type de bip dsir.';
  hcOColors      : Hint:=' Dfinit les couleurs de l''environnement';
  hcCConfBtn     : Hint:=' Confirme les changements';
  hcOLoad        : Hint:=' Recharge les valeurs prcdemment sauvegardes';
  hcOMouse       : Hint:=' Dfinit les caractristiques de la souris';
  hcOPref        : Hint:=' Dfinit les prfrences utilisateur';
  hcOptions      : Hint:=' Modifie les paramtres de l''environnement';
  hcORacc        : Hint:=' Modifie les touches raccourcis';
  hcORaccBox     : Hint:=' Edition des touches raccourcis';
  hcOTyp         : Hint:=' Modifie les types raccourcis';
  hcOTypBox      : Hint:=' Edition des types raccourcis';
  hcOStore       : Hint:=' Sauvegarde l''tat actuel de l''environnement';
  hcOVideo       : Hint:=' Change de mode vido 25 Lignes <-> 43/50 Lignes';
  hcPrint        : Hint:=' Oprations concernant l''impression';
  hcRaccImpBtn   : Hint:=' Imprime un mmo des touches "Raccourci"';
  hcRun          : Hint:=' Lance une macro automatique';
  hcSAbout       : Hint:=' Donne la version du programme et le nom de l''auteur';
  hcSCalculator  : Hint:=' Ouvre la calculatrice';
  hcSCalendar    : Hint:=' Ouvre le calendrier';
  hcSystem       : Hint:=' Menu systme';
  hctestbeepbtn  : Hint:=' Ecoute la sonorit du type de bip choisi.';
  hcTools        : Hint:=' Outils de manipulation des comptes';
  hcTClass       : Hint:=' Classe la slection';
  hcTSearch      : Hint:=' Recherche un montant';
  hcTCRev        : Hint:=' Renverse l''ordre de tri';
  hcTCDate       : Hint:=' Tri par dates';
  hcTCLib        : Hint:=' Tri par libells';
  hcTCSel        : Hint:=' Tri selon slecteur';
  hcTSMont       : Hint:=' Montant  rechercher';
  hcCTypeU       : Hint:=' Slectionne le type compte Unique.';
  hcCTypeM       : Hint:=' Slectionne le type compte Mensuel.';
  hcCTypeA       : Hint:=' Slectionne le type compte Annuel.';
  hcWCascade     : Hint:=' Dispose les fentres en cascade';
  hcWClose       : Hint:=' Ferme la fentre courante';
  hcWDuplique    : Hint:=' Duplique le compte courant';
  hcWindow       : Hint:=' Oprations sur la fentre courante';
  hcWNext        : Hint:=' Passe  la fentre suivante';
  hcWPrevious    : Hint:=' Passe  la fentre prcdente';
  hcWSizeMove    : Hint:=' Retaille et/ou bouge la fentre courante';
  hcWTile        : Hint:=' Dispose les fentres sous forme de mosaque';
  hcWZoom        : Hint:=' Commute le mode Zoom sur la fentre courante';
  end;
end;

constructor TCptInputLine.init(var Bounds: TRect; Verif:byte);

begin
TInputLine.init(Bounds, LG_NAME);
CheckName:=Verif;
OkName:=#255;
end;

function TCptInputLine.Valid(cm:word):boolean;

 var Ok:boolean;
     R:TRect;
     LG:Byte;

begin
  Ok:=TInputLine.Valid(cm);

  R.assign(20,7,60,14);

  if Data^='' then
   begin
   Beep;
   MessageBoxRect(R,^C+'Nom de compte incorrect',
    nil, mfError + mfOkButton);
   Ok:=false;
   end;

  LG:=255;
  if CheckName=0 then LG:=0;
  if CheckName=2 then LG:=length(Data^);

  if ExistCpt(Data^,LG) and ( (CheckName<>3) or (OkName<>Data^) ) then
   begin
   Beep;
   MessageBoxRect(R,^C+'Ce compte existe dja !',
    nil, mfError + mfOkButton);
   Ok:=false;
   end;

  Valid:=Ok;
end;
